#ifndef	lint
static char rcsid[] = "$Id: color_buttons.c,v 1.2 1995/01/29 21:18:38 sydd Exp $ SyddWare";
#endif
/*****************************************************************************
* Classification:    Unclassified
*
* Project:           SDRTOOL
*
* Module Name:       color_buttons.c
*
* Description:
*   This function reverses the fg/bg colors of any Edit/View buttons that
*	a file with the sdr id passed and the extension from the button is found.
*
* Calling Sequence:
*
*   Inputs:
*       None
*
*   Outputs:
*       None
*
*   Returns:
*       None
*
* Error Conditions and Actions:
*   N/A
*
* Side Effects:
*   N/A
*
* Limitations:
*	N/A
*
* Notes:
*   N/A
*
* Revision History
*   DATE    S/W ENGINEER     DESCRIPTION OF WORK
* --------  ---------------  ------------------------------------------------
* 03/29/94  J.R.(Sydd)Souza  Created
******************************************************************************/
/*
**	Includes
*/ 
#include <sys/types.h>	/* for struct stat */
#include <sys/stat.h>	/* for stat prototype */
#include "sdr_.h"	/* for this routine's prototype */

#ifdef	COMMENT_OUT	/* sun includes don't have true prototype */
#ifdef	__STDC__	/* gcc does */
int	stat
	PROTO((	char *path,
			struct stat *buf ));
#endif	/* __STDC__ */
#endif	/* COMMENT_OUT */


/*
**	Function color_buttons
*/
void	color_buttons ( sdr_id )
	char	*sdr_id;
{
	/*
	**	Local variables
	*/
	static	int	kvalue[] =
				{
					k_buildpushButton,
					k_descriptionpushButton,
					k_filespushButton,
					k_impactpushButton,
					k_problempushButton,
					k_resolutionpushButton,
					k_solutionpushButton,
					k_stepspushButton,
					k_testingpushButton,
					k_seevalidatepushButton,
					k_seeperformpushButton,
					(int)0,
				};
	char		*extension = (char *)0;
	Pixel		fg, bg;
	struct	stat	filestatus;
	int			icnt;
    char        *text;
    XmString            origstring;
    XmStringContext     context;
    XmStringCharSet     charset;
    XmStringDirection   direction;
    Boolean             separator;
	char		editfilename[256];
	char		system_command[256];

	/*
	**	Function color_buttons body
	*/
	if (sdr_id[0] != ORIGINAL_PREFIX)
		return;

	/* obtain normal fg & bg from Help button that NEVER changes */
	XtVaGetValues(Widget_list[k_helppushButton],
		XmNforeground, &fg,
		XmNbackground, &bg,
		NULL);

	for (icnt=0;kvalue[icnt];++icnt)
	{
		system_command[0] = '\0';
		if (Widget_list[kvalue[icnt]])
		{
			/* get XmNuserData from Widget w to figure out extension */
			XtVaGetValues(Widget_list[kvalue[icnt]],
				XmNuserData, &extension, NULL);

			XtVaGetValues(Widget_list[kvalue[icnt]],
                XmNlabelString, &origstring, NULL);
            XmStringInitContext(&context,origstring);
            XmStringGetNextSegment(context,
                &text, &charset, &direction, &separator);
            XmStringFreeContext(context);
            XmStringFree(origstring);

			strcpy(system_command,text);
			sprintf(editfilename,"%s/%s/%s%s", SdrTool.sdrpath, extension,
				sdr_id, extension);
			if (!stat(editfilename,&filestatus) &&
				filestatus.st_size > 0)
			{
				/* swap fg & bg on button */
				XtVaSetValues( Widget_list[kvalue[icnt]],
					XmNforeground, bg,
					XmNbackground, fg,
					NULL);
				if (kvalue[icnt] == k_seeperformpushButton &&
					XtIsSensitive(Widget_list[k_dovalidatepushButton]) &&
					strcmp(username,SdrTool.cmaccountname))
					XtSetSensitive(Widget_list[k_dovalidatepushButton],
                        False);
			}
			else
			{
				/* normal fg & bg on button */
				XtVaSetValues( Widget_list[kvalue[icnt]],
					XmNforeground, fg,
					XmNbackground, bg,
					NULL);
				if (kvalue[icnt] == k_seeperformpushButton &&
					!XtIsSensitive(Widget_list[k_dovalidatepushButton]))
					XtSetSensitive(Widget_list[k_dovalidatepushButton],
                        True);
			}

			sprintf(editfilename,"%s/%s%s",Tempdir,
				sdr_id, extension);

			if (!stat(editfilename,&filestatus) &&
               	filestatus.st_size > 0)
			{ /* Tempdir version exists */
				if (!strrchr(system_command,'*'))
					strcat(system_command,"*");
				else
					system_command[0] = '\0';
			}
			else
			{ /* Tempdir version exists */
				if ((text = strrchr(system_command,'*')))
					*text = '\0';
				else
					system_command[0] = '\0';
			}
			if (system_command[0])
			{
				origstring = XmStringCreateLtoR(system_command,
                     XmFONTLIST_DEFAULT_TAG);
                XtVaSetValues(Widget_list[kvalue[icnt]],
                    XmNlabelString, origstring, NULL);
                XmStringFree(origstring);
				system_command[0] = '\0';
			}
		}
	}
	return;
} /* end function : color_buttons */
/* end file : color_buttons.c */
