#ifndef	lint
static char rcsid[] = "$Id: docmd_callback.c,v 1.2 1995/01/29 21:18:38 sydd Exp $ SyddWare";
#endif
/*****************************************************************************
* Classification:    Unclassified
*
* Project:           SDRTOOL
*
* Module Name:       docmd_callback.c
*
* Description:
*   
*
* Calling Sequence:
*   
*
*   Inputs:
*       None
*
*   Outputs:
*       None
*
*   Returns:
*       None
*
* Error Conditions and Actions:
*   N/A
*
* Side Effects:
*   N/A
*
* Limitations:
*   N/A
*
* Notes:
*   N/A
*
* Revision History
*   DATE    S/W ENGINEER     DESCRIPTION OF WORK
* --------  ---------------  ------------------------------------------------
* 04/05/94  J.R.(Sydd)Souza  T00000 - Placed Under CM Control
******************************************************************************/
#include "sdr_.h"	/* for this prototype */
#include "sdr_g.h"	/* for globals */

void docmd_callback(w, which_one, call)
	Widget w;
	int *which_one;
	XmPushButtonCallbackStruct *call;
{
	char 		*argv[256];
	char		*extension = (char *)0;
				/* should be able to take filename as single parm */
	char		*idptr;
	char		*shellcommand;
	char		*text;
    XmString            origstring;
    XmStringContext     context;
    XmStringCharSet     charset;
    XmStringDirection   direction;
    Boolean             separator;
	pid_t		process_pid; /* needs to be one of 9 entries in a table */
	int			icnt;
	int			notvalidate = -1;
	int			notperform = -1;
	int			table_entry;
	char		originalpath[256];
	char		editfilename[256];
	char		system_command[256];
	ID_CODE_T	id;
	SDR_T		sdr;

	/* get XmNuserData from Widget w to figure out extension */
	XtVaGetValues(w, XmNuserData, &extension, NULL);

	for (table_entry=0; extension && Process_table[table_entry].extension &&
		strcmp(Process_table[table_entry].extension, extension); ++table_entry)
		DO_NOTHING;

	if (!extension || !Process_table[table_entry].extension ||
		((notvalidate = strcmp(extension,VALIDATED_EXT)) &&
		 (notperform = strcmp(extension,PERFORMED_EXT))))
	{
		/* !PING! bad extension for some reason */
		if (!extension)
		{
			BEEP_MESSAGE("Bad extension <null>");
		}
		else if (!Process_table[table_entry].extension)
		{
			sprintf(originalpath,"Extension not found [%s]",
				extension);
			BEEP_MESSAGE(originalpath);
		}
		else
		{
			sprintf(originalpath,"Command not supported for extension [%s]",
				extension);
			BEEP_MESSAGE(originalpath);
		}
		return;
	}
	else if (Process_table[table_entry].pid != -1)
	{
		/* !PING! already editing that one */
		sprintf(originalpath,"Please quit editing the %s file first!",
			extension);
		BEEP_MESSAGE(originalpath);
		return;
	}

	/* only cm user is allowed to do the perform thing */
	if (!notperform)
	{
    	if (strcmp(username,SdrTool.cmaccountname))
		{
			BEEP_MESSAGE("You are not the CM user, permission denied");
			return;
		}
	}

	/*	Yank id from k_idtextField */
	idptr = XmTextFieldGetString( Widget_list[ k_idtextField ] );
	if (!idptr)
	{
		/* !PING! gotta choose */
		BEEP_MESSAGE("You must first choose an ID");
		return;
	}
	s_toupper(idptr);
	strip_whitespace(idptr);
	if (!isvalidid(idptr))
	{
		/* !PING! gotta choose a valid one! */
		XtFree(idptr);
		idptr = (char *)0;
		BEEP_MESSAGE("Invalid SDR ID");
		return;
	}

	/*
	**	If id != ORIGINAL_PREFIX (or lowercase version)
	**	retrieve current record, if any, from database into sdr.
	*/
	
	if (idptr[0] == ORIGINAL_PREFIX ||
		toupper(idptr[0]) == ORIGINAL_PREFIX)
	{
		strncpy(sdr.id[0],idptr,sizeof(ID_CODE_T));
		sdr.id[0][sizeof(ID_CODE_T)-1] = '\0';
		sdr.id[1][0] = '\0';
	}
	else
	{
		sdr.id[0][0] = '\0';
		strncpy(sdr.id[1],idptr,sizeof(ID_CODE_T));
		sdr.id[1][sizeof(ID_CODE_T)-1] = '\0';
	}
	XtFree(idptr); /* a bit of cleanup */
	idptr = (char *)0;

	get_current_record(&sdr);	/* will reset id[0] to null if nf */
	strcpy(id,sdr.id[0]);

	strncpy(Process_table[table_entry].id, id,
		sizeof(Process_table[table_entry].id)-1);
	Process_table[table_entry].id[sizeof(Process_table[table_entry].id)-1] =
		'\0';

	if (!notvalidate)
		shellcommand = "validate_turnover -quiet";
	else
		shellcommand = "perform_turnover -quiet";

	sprintf(system_command,"%s %s", shellcommand, id);
	DIAG1(docmd_callback:,system_command,s);
	/* break up parms by whitespace */
	for (icnt=0; icnt<256; ++icnt)
	{
		if (!icnt)
			argv[icnt] = strtok(system_command," \t");
		else
			argv[icnt] = strtok(NULL," \t");
		if (!argv[icnt])
			break;
	}
	argv[255] = (char *)0;

	/*
	**	Fork off an exact copy of this process - the copy will gain control
	**	from where the fork command left off with commsproc_id set to 0
	**	(meaning it's the child).  The original parent will get back a pid > 0
	*/
	switch ( process_pid = fork ())
	{
	    case -1: 
			errno = ENOEXEC;
			return;
			/* break; */

	    case 0: 
			/*
			**	Forked process gains control of the process here, so
			**	exec the real process (control will not return from the
			**	exec call unless it fails).
			*/
			DIAG(docmd_callback: about to execvp);
			errno = ESRCH; /* for lack of anything better */
			execvp (argv[0], argv);
			perror
				("sdrtool: Should not have but returned from execvp on edit.");
			/* no-one to return to so just terminate */
			exit(errno);
			/* break; */

	    default: 
			/* parent regains control here */
			DIAG(docmd_callback: back in parent);
			Process_table[table_entry].pid = process_pid;	/* save it */
			/* change the label so they know it's running */
			XtVaGetValues(w,
          		XmNlabelString, &origstring, NULL);
    		XmStringInitContext(&context,origstring);
    		XmStringGetNextSegment(context,
          		&text, &charset, &direction, &separator);
    		XmStringFreeContext(context);
    		XmStringFree(origstring);
			sprintf(system_command," [ %s ] ", text);
			origstring = XmStringCreateLtoR(system_command,
				XmFONTLIST_DEFAULT_TAG);
			XtVaSetValues(w,
				XmNlabelString, origstring, NULL);
			XmStringFree(origstring);
			break;
	}
	DIAG1(docmd_callback: leaving,process_pid,d);
	return;
}
