#ifndef	lint
static char sccsid[] = "$Id: lockout_idfile.c,v 1.1 1995/01/24 05:16:42 sydd Exp $ SyddWare";
#endif
/*****************************************************************************
* Classification:    Unclassified
*
* Project:           SDRTOOL
*
* Module Name:       lockout_idfile.c
*
* Description:
*   
*
* Calling Sequence:
*   
*
*   Inputs:
*       None
*
*   Outputs:
*       None
*
*   Returns:
*       None
*
* Error Conditions and Actions:
*   N/A
*
* Side Effects:
*   N/A
*
* Limitations:
*   N/A
*
* Notes:
*   N/A
*
* Revision History
*   DATE    S/W ENGINEER     DESCRIPTION OF WORK
* --------  ---------------  ------------------------------------------------
*
******************************************************************************/
#include <Xm/Xm.h>
#include "sdr_.h"
#include "sdrtags.h"

#define	MAX_RETRIES	5	/* number of times to sleep(1) waiting for lock file */

static char	RealLockName[256];

#ifdef	COMMENT_OUT
int	gethostname
	PROTO((	char *hostname,
			int	namesize ));
#endif	/* COMMENT_OUT */

BOOLEAN	lockout_idfile(idfilename)
	char **idfilename;
{
/*
**	returns FALSE & idfilename if lock established,
**	TRUE with errno set otherwise
*/
	FILE	*idfile = (FILE *)0;
	FILE	*lockf = (FILE *)0;
	int		retries;
	char	buffer[80];	/* for line reads from file */

	/* build lockfile by adding .lock ro sdridfile name */
	sprintf(RealLockName,"%s/%s.lock", SdrTool.sdrpath,SdrTool.sdridfile);

	/* first check for lockage */
	for (retries=0;retries<MAX_RETRIES &&
		!access(RealLockName,NOTEXIST);++retries)
		sleep(1);

	if (retries == MAX_RETRIES ||
		!(lockf = fopen(RealLockName,"w")))	/* never got it */
	{
		BEEP_MESSAGE("Unable to obtain lock on IDFile - try again");
		*idfilename = (char *)0;
		errno = EACCES;
		return TRUE;
	}
	gethostname(buffer,sizeof(buffer));	/* NOBODY has an 80 char hostname! */
	fprintf(lockf,"Process %d on %s has the lock", getpid(), buffer);
	fclose(lockf);
	*idfilename = RealLockName;
	return FALSE;
}
