/*****************************************************************************
* @(#)sdr.h	1.3 6/25/94 SyddWare
*
* Classification:  Unclassified
*
* Project:         SDRTOOL
*
* Binding Name:    sdr.h
*
* Description:
*   Constants for the sdrtool.
*
* Notes:
*   N/A
*
* Revision History
*   DATE    S/W ENGINEER     DESCRIPTION OF WORK
* --------  ---------------  ------------------------------------------------
* 04/01/94  J.R.(Sydd)Souza  Created
******************************************************************************/
#ifndef	SDR_H
#	define SDR_H

/* for non-ANSI compilers */
#	ifndef __STDC__
#		ifndef	_NO_PROTO
#			define	_NO_PROTO
#		endif /* _NO_PROTO */
#		define	void
#	endif	/* __STDC__ */

#	ifndef	X_OK	/* execute flag for access() call */
#		define	X_OK	1
#	endif	/* !X_OK */
#	ifndef	NOTEXECUTABLE	/* ditto but more readable in code */
#		define	NOTEXECUTABLE X_OK
#	endif	/* !NOTEXECUTABLE */

/*
**	Constants for file extensions.  Filename prefix will be id number
**	except for new files which will use the pid.
*/
#	define	BUILD_EXT		".build_instructions"
#	define	DESCRIPTION_EXT	".description"
#	define	FILES_EXT		".files_modified"
#	define	COMMENTS_EXT	".comments"
#	define	PROBLEM_EXT		".problem"
#	define	RECREATE_EXT	".steps_to_recreate"
#	define	RESOLUTION_EXT	".resolution"
#	define	SOLUTION_EXT	".proposed_solution"
#	define	TESTING_EXT		".testing"
#	define	VALIDATED_EXT	".validated"
#	define	PERFORMED_EXT	".performed"
#	define	HELP_FILE_EXT	".help"
#	define	HELP_FILE_NAME	"online"

/* Names of environment Variables supported & their defaults */

/*
**	Editor command: should take filename as single parm.
**	NOTE: no separate READ-ONLY version provided - all files, however,
**	are edited from /tmp & only those allowed to be changed when Apply
**	is pressed are updated, so it doesn't matter WHAT they do to the files.
**	NOTE2: The environment variable SDREDITOR may be provided at runtime
**	by users who have their own preference.  Editor should be one that
**	causes a window to come up.  See Notes for how to use vi from an
**	xterm for this.  We've also successfully used the X Window based
**	Emacs too.  THUS, THE DEFAULT HERE IS ONLY USED IF THE USER DOES NOT
**	PROVIDE A VALUE FOR SDREDITOR AND NO DEFEDITOR VALUE IS PROVIDED
**	AT COMPILE TIME.  (Even if a DEFEDITOR is provided at compile time,
**	The user can override it with their own.)
*/
#	define	SDREDITOR	"SDREDITOR"
#	ifndef	DEFEDITOR	/* may be provided at compile time */
#		define	DEFEDITOR	"/usr/local/bin/xvi"
#	endif	/* DEFEDITOR */

#	ifndef	SDRPATH	/* may be provided at compile time */
#		define	SDRPATH		"/usr/local/sdr"	/* default path */
#	endif	/* SDRPATH */

#	ifndef	SDRIDFILE	/* may be provided at compile time */
#		define	SDRIDFILE	".assign"		 	/* default filename  */
#	endif	/* SDRIDFILE */

/*
**	The following command is expected to take the actual SQL commands as
**	redirected from a file and send output to stdout.  See the notes
**	on this in the globals file.
*/
#	ifndef	SDRSQLCMD	/* may be provided at compile time */
#		define	SDRSQLCMD	"dbaccess" /* default */
#	endif	/* SDRSQLCMD */

/*
**	Account name of ccb CM user
*/
#	ifndef	CM_ACCOUNTNAME	/* may be provided at compile time */
#		define	CM_ACCOUNTNAME	((char *)"cm")
#	endif	/* CM_ACCOUNTNAME */

/*
**	List of members of the CCB (account names for email purposes)
**	This should be one string
**	If you want to make it multiple users, place all names in a single
**	string separated by commas (e.g. "bob,sam").  This should include all
**	CCB member's accountnames NOT INCLUDING CM_ACCOUNTNAME which is sent
**	a copy separately (when applicable).
*/
#	ifndef	CCB_MEMBERS	/* may be provided at compile time */
#		define	CCB_MEMBERS	((char *)"souza")
#	endif	/* CCB_MEMBERS */

/* constants for field sizes */
#	define	ID_CODE_SIZE		(6)		/* A##### */
#	define	TITLE_SIZE			(50)
#	define	ORIGINATOR_SIZE		(25)
#	define	TROUBLE_AREA_SIZE	(75)
#	define	ASSIGNED_SIZE		(25)
#	define	CPC_CODE_SIZE		(2)		/* two character mnemonic */
#	define	THREAD_SIZE 		(30)
#	define	DATE_STRING_SIZE	(24)	/* "MMM dd yyyy hh:mmAM" */

#define	MAX_SQL_STRING_LEN	1024

#define	SDRTOOL_DB_NAME	"sdrtool_db"

#endif	/* SDR_H */
/* end file : sdr.h */
