/*****************************************************************************
* @(#)sdr_g.h	1.3 6/25/94 SyddWare
*
* Classification:  Unclassified
*
* Project:         SDRTOOL
*
* Binding Name:    sdr_g.h
*
* Description:
*   Globals related to SDRTool.
*
* Notes:
*   N/A
*
* Revision History
*   DATE    S/W ENGINEER     DESCRIPTION OF WORK
* --------  ---------------  ------------------------------------------------
* 04/01/93  J.R.(Sydd)Souza  Created
******************************************************************************/
#ifndef	SDR_G_H
#	define SDR_G_H

#	if defined(__CLCC__) && defined(__STDC__)
#  	 pragma Warning_level(0)
#	endif
#	include <X11/Xlib.h>
#	include <Mrm/MrmAppl.h>
#	if defined(__CLCC__) && defined(__STDC__)
#   	pragma Warning_level(4)
#	endif

#	include "generi.h"		/* for EXTERN */
#	include "sdr_t.h"		/* for PROCESS_TABLE_T */
#	include "sdrtags.h"		/* for MAX_TAGS */

/*
**	Working directory (usually /tmp/[getpid()]
*/
EXTERN	char	Tempdir[L_tmpnam];

/*
**	Global to store resources
*/
EXTERN	AppData	SdrTool;

/*
**	Global to store widget ids of widgets that may change values;
**	filled by calls to create_callback().
*/
EXTERN	Widget	Widget_list[MAX_TAGS];

/* used to keep track of which files we're currently editing: -1=not editing */
EXTERN	PROCESS_TABLE_T	Process_table[]
#	ifdef	MAIN_PROGRAM
= {
	{ BUILD_EXT,		-1, ""  },	/* note: 3rd mem holds id in use */
	{ DESCRIPTION_EXT,	-1, ""  },
	{ FILES_EXT,		-1, ""  },
	{ COMMENTS_EXT,		-1, ""  },
	{ PROBLEM_EXT,		-1, ""  },
	{ RECREATE_EXT,		-1, ""  },
	{ RESOLUTION_EXT,	-1, ""  },
	{ SOLUTION_EXT,		-1, ""  },
	{ TESTING_EXT,		-1, ""  },
	{ VALIDATED_EXT,	-1,	""  },
	{ PERFORMED_EXT,	-1,	""  },
	{ HELP_FILE_EXT,	-1, ""  },
	{ (char *)0,		-1, ""  }
  }
#	endif	/* MAIN_PROGRAM */
; /* 1 for each ext, null terminated list */

/*
**	SdrTool.sdrpath
** This is the base directory beneath which we find the following:
**	.	- .mail_me_one script for mailing a copy to a user
**		- DEFIDFILE file holding current "next ids"
**		- .replace_files script for replacing N##### files in SCCS
**		- SCCS main dir for N#####.* file storage
**		- .build_instructions directory for N##### files & link to ../SCCS
**		- .description directory for N##### files & link to ../SCCS
**		- .files_modified directory for N##### files & link to ../SCCS
**		- .comments directory for N##### files & link to ../SCCS
**		- .problem directory for N##### files & link to ../SCCS
**		- .steps_to_recreate directory for N##### files & link to ../SCCS
**		- .resolution directory for N##### files & link to ../SCCS
**		- .proposed_solution directory for N##### files & link to ../SCCS
**		- .testing directory for N##### files & link to ../SCCS
**		- .validated directory for N##### files & link to ../SCCS
**		- .performed directory for N##### files & link to ../SCCS
**		- .help directory for online.help file (Help button)
*/

/*
**	SdrTool.sdridfile
**	This is the name of the file containing the NEXT id to be used in each
**	category, 1 per line.  Later the syntax may be more forgiving, but for
**	now, 1 per line, firstword, no particular order (see sample file).
**	Numbers in here are "one upped" by get_next_id().
*/

/*
**	SdrTool.sdrsqlcmd
**	This is the text of the command to be used for all database updates.
**	NOTE: This command should cause the results of any given command to
**	appear totally on a line.  In other words, (and especially) the single
**	record query will probably take upwards of 500 bytes to display.  If
**	your command automatically splits lines at 80 (or some other auto)
**	column limit [as does Sybase's isql command - at 80]) but has a way of
**	specifying a longer line limit (-w switch for isql), you should use
**	it with around 500 as the limit.  See the default in the sdr.h file.
**	All commands will take the following form:
**		In a separate file:
**			<command - insert, update or query>
**			go
**			exit
**		Executed via system() call:
**		Sqlcmd < commandfile > logfile
*/

/*
**	SdrTool.ccbmembers
**	This should be one string.
**	If you want to make it multiple users, place all names in a single
**	string separated by commas (e.g. "bob,sam").  This should include all
**	CCB member's accountnames NOT INCLUDING CCB_ACCOUNTNAME which is sent
**	a copy separately (when applicable).
*/

/*
** These are populated in sdrtables.c generated by the mkchoices script
*/
EXTERN	struct	CPC_NAME_STRUCT
{
	char *mnemonic;
	char *name;
	Widget	widgee;
} CPC_table[];

EXTERN	struct	VENDOR_NAME_STRUCT
{
	char *name;
	Widget	widgee;
} vendor_table[];

EXTERN	struct DOCUMENT_NAME_STRUCT
{
	char *name;
	Widget	widgee;
} document_table[];

EXTERN	struct HARDWARE_NAME_STRUCT
{
	char *name;
	Widget	widgee;
} hardware_table[];

#endif	/* SDR_G_H */
/* end file : sdr_g.h */
