#ifndef	lint
static char sccsid[] = "$Id: sdrtool.c,v 1.3 1995/01/30 02:18:23 sydd Exp $ SyddWare";
#endif
/*****************************************************************************
* Classification:    Unclassified
*
* Project:           SDRTOOL
*
* Module Name:       sdrtool.c
*
* Description:
*   
*
* Calling Sequence:
*   
*
*   Inputs:
*       None
*
*   Outputs:
*       None
*
*   Returns:
*       None
*
* Error Conditions and Actions:
*   N/A
*
* Side Effects:
*   N/A
*
* Limitations:
*   N/A
*
* Notes:
*   N/A
*
* Revision History
*   DATE    S/W ENGINEER     DESCRIPTION OF WORK
* --------  ---------------  ------------------------------------------------
*
******************************************************************************/

/*
 * Generated by the ICS builderXcessory (BX).
 *
 *
 * Builder Xcessory 2.5.
 *
 */
/*
 * System Include Files
 */
#include <stdlib.h>
#include <signal.h>
#include <sys/stat.h>	/* for S_IRWXU etc */

/*
 * Required Motif Include Files
 */
#include <X11/Xlib.h>
#if defined(__CLCC__) && defined(__STDC__)
#   pragma Warning_level(0)
#endif
#include <Mrm/MrmAppl.h>
#if defined(__CLCC__) && defined(__STDC__)
#   pragma Warning_level(4)
#endif

#define	MAIN_PROGRAM
#include "sdr_.h"	/* everything else is from here */
#include "sdr_g.h"	/* globals */

static MRMRegisterArg NamesList[] =
{
    { "apply_abort_callback",   (XtPointer)apply_abort_callback },
    { "create_callback",        (XtPointer)create_callback },
    { "docmd_callback",         (XtPointer)docmd_callback },
    { "edit_file_callback",     (XtPointer)edit_file_callback },
    { "mail_me_one",            (XtPointer)mail_me_one },
    { "value_changed_callback", (XtPointer)value_changed_callback },
    { "destroy_main",           (XtPointer)destroy_main },
};

/*
 * Main Program.
 */
main(argc, argv)
	int argc;
	char **argv;
{
	Display *display;
	XtAppContext context;
	Cardinal	argcnt;
	char	*title = (char *)0;
	char	*sdrpath = (char *)0;
	char	*sdridfile = (char *)0;
	char	*ccbmembers = (char *)0;
	char	*cmaccountname = (char *)0;
	int	icnt;
	SUPPORT_T   Supported_tables[4];


	/*
	** Hierarchy variables
	*/
	MrmHierarchy HierarchyID;
	MrmType MrmWClass;

	/* Initialize table */
	Supported_tables[0].dbname = "abf";
	Supported_tables[0].uidfilename = "abf_sdrtables.uid";
	Supported_tables[0].CPC_table = abf_CPC_table;
	Supported_tables[0].vendor_table = abf_vendor_table;
	Supported_tables[0].document_table = abf_document_table;
	Supported_tables[0].hardware_table = abf_hardware_table;
	Supported_tables[1].dbname = "cids";
	Supported_tables[1].uidfilename = "cids_sdrtables.uid";
	Supported_tables[1].CPC_table = cids_CPC_table;
	Supported_tables[1].vendor_table = cids_vendor_table;
	Supported_tables[1].document_table = cids_document_table;
	Supported_tables[1].hardware_table = cids_hardware_table;
	Supported_tables[2].dbname = "ods";
	Supported_tables[2].uidfilename = "ods_sdrtables.uid";
	Supported_tables[2].CPC_table = ods_CPC_table;
	Supported_tables[2].vendor_table = ods_vendor_table;
	Supported_tables[2].document_table = ods_document_table;
	Supported_tables[2].hardware_table = ods_hardware_table;
	Supported_tables[3].dbname = "reccon";
	Supported_tables[3].uidfilename = "reccon_sdrtables.uid";
	Supported_tables[3].CPC_table = reccon_CPC_table;
	Supported_tables[3].vendor_table = reccon_vendor_table;
	Supported_tables[3].document_table = reccon_document_table;
	Supported_tables[3].hardware_table = reccon_hardware_table;

	/*
	**	Force to Eastern Time for now because I'm not sure why it uses
	**	GMT currently & how the clocks get the right time...
	*/
#	ifdef	COMMENT_OUT
	if (!getenv("TZ"))
		(void)putenv("TZ=EST5EDT");
#	endif	/* COMMENT_OUT */

	sprintf(Tempdir,"/tmp/%d", getpid());
	if (!access(Tempdir,NOTEXIST))
	{
		rmdir(Tempdir);
	}
	mkdir(Tempdir,S_IRWXU|S_IRWXG);

	memset(&SdrTool, 0, sizeof(SdrTool));
	/*
	**	Install child reaper
	*/
	INSTALL_SIGNAL_HANDLER(SIGCHLD, SIGCHLD_handler);

    MrmInitialize();
    XtToolkitInitialize();
    context = XtCreateApplicationContext();
    display = XtOpenDisplay(context, 0, APP_NAME, APP_CLASS, 
#ifndef XtSpecificationRelease
        0, 0, (Cardinal*)&argc, argv);
#else
#if XtSpecificationRelease == 4
        0, 0, (Cardinal*)&argc, argv);
#else
        0, 0, &argc, argv);
#endif
#endif
    if(display == NULL)
    {
		char termessage[256];

		sprintf(termessage,"%s: Cannot open display - terminating",argv[0]);
		XtWarning(termessage);
		exit(ENXIO);
    }
	if (argc < 1)
	{
		char termessage[256];

		sprintf(termessage,"%s: Error - You must specify a database table name",
			argv[0]);
		XtWarning(termessage);
        exit(ENOENT);
    }
	else
	{
		s_tolower(argv[0]);
		for (icnt=0;argv[0][icnt] && isalnum(argv[0][icnt]);++icnt);
		if (argv[0][icnt])
		{
			char termessage[256];

			sprintf(termessage,"%s: Error - You must specify a database table \
name\n   using alphanumeric characters ONLY (letters & numbers case \
independent.\n",
				argv[0]);
			XtWarning(termessage);
        	exit(EINVAL);
		}

		for (icnt=0; Supported_tables[icnt].dbname &&
			strcmp(argv[1],Supported_tables[icnt].dbname);++icnt);
		if (!Supported_tables[icnt].dbname)
		{
			char termessage[256];

			sprintf(termessage,"%s: Unsupported database %s: Contact your\n\
local Syddware vendors to add support or try one of these:\n",
				argv[0], argv[1]);
			XtWarning(termessage);
			termessage[0] = '\0';
			for (icnt=0; Supported_tables[icnt].dbname;++icnt)
			{
				strcat(termessage," ");
				strcat(termessage,Supported_tables[icnt].dbname);
			}
			XtWarning(termessage);
        	exit(EINVAL);
		}
		else
		{
			Table_name = Supported_tables[icnt].dbname;
			UidFile[1] = Supported_tables[icnt].uidfilename;
			CPC_table = Supported_tables[icnt].CPC_table;
			vendor_table = Supported_tables[icnt].vendor_table;
			document_table = Supported_tables[icnt].document_table;
			hardware_table = Supported_tables[icnt].hardware_table;
		}
	}

    /*
     * So converters work.
     */
    XtInitializeWidgetClass(applicationShellWidgetClass);

	/*
	 *	Setup the title with "SDRTool: [dbname] {username]"
	 */
	get_username(username);
	title = (char *)CALLOC(1,strlen("SDRTool: [%s] {%s}")+strlen(Table_name)+
		strlen(username)+1);
	sprintf(title,"SDRTool: [%s] {%s}", Table_name, username);
	for (icnt=0; args[icnt].name && strcmp(args[icnt].name,XmNtitle);++icnt);
	if (args[icnt].name)
		args[icnt].value = (XtArgVal)title;

    /*
     * The applicationShell is created as an unrealized
     * parent for multiple topLevelShells.  The topLevelShells
     * are created as popup children of the applicationShell.
     * This is a recommendation of Paul Asente & Ralph Swick in
     * _X_Window_System_Toolkit_ p. 677.
     */
    AppShell = XtAppCreateShell( APP_NAME, APP_CLASS,
            applicationShellWidgetClass, display, args, 0);
	FREE(title);
    HierarchyID = 0;
#ifdef	MOTIF_1_1
    argcnt = MrmOpenHierarchy((MrmCount)(2),UidFile,0,&HierarchyID);
#else	/* Assume 1.2 */
    argcnt = MrmOpenHierarchyPerDisplay(display, (MrmCount)(2),UidFile,0,
		&HierarchyID);
#endif	/* MOTIF_1_1 */
	if (MrmSUCCESS != argcnt)
	{
		char termessage[256];

		sprintf(termessage, "\
Please make sure its path appears in the UIDPATH environment variable -\n\
or in a standard X location.\n");
		XtWarning(termessage);
		exit(EBADF);
	}
    MrmRegisterNames(NamesList, XtNumber(NamesList));
    XtInitializeWidgetClass(topLevelShellWidgetClass);

    Shell000 = XtCreatePopupShell( "SDRTool", 
        topLevelShellWidgetClass, AppShell, args, XtNumber(args));

    XtAddCallback((Widget)Shell000, XmNdestroyCallback,
		(XtCallbackProc)destroy_main, (XtPointer)0);

	/*
	**	Get resources specific to this one.
	*/
	sdrpath = (char *)CALLOC(1,strlen(".sdrPath") +
		strlen(Table_name) + 1);
	sprintf(sdrpath, "%s.sdrPath", Table_name);
	resources[0].resource_name = sdrpath;

	sdridfile = (char *)CALLOC(1,strlen(".sdrIdFile") +
		strlen(Table_name) + 1);
	sprintf(sdridfile, "%s.sdrIdFile", Table_name);
	resources[1].resource_name = sdridfile;

	/* Note: resources[2] (sdrsqlcmd) is assumed to be the same for all dbs */

	cmaccountname = (char *)CALLOC(1,strlen(".sdrCmAcct") +
		strlen(Table_name) + 1);
	sprintf(cmaccountname, "%s.sdrCmAcct", Table_name);
	resources[3].resource_name = cmaccountname;

	ccbmembers = (char *)CALLOC(1,strlen(".sdrCcb") +
		strlen(Table_name) + 1);
	sprintf(ccbmembers, "%s.sdrCcb", Table_name);
	resources[4].resource_name = ccbmembers;

	XtGetApplicationResources(AppShell, &SdrTool,
		resources, XtNumber(resources), NULL, 0);

	FREE(ccbmembers);
	FREE(cmaccountname);
	FREE(sdridfile);
	FREE(sdrpath);

#ifdef	COMMENT_OUT
	printf("sdrpath=[%s]\n",SdrTool.sdrpath);
	printf("sdridfile=[%s]\n",SdrTool.sdridfile);
	printf("sdrsqlcmd=[%s]\n",SdrTool.sdrsqlcmd);
	printf("cmaccountname=[%s]\n",SdrTool.cmaccountname);
	printf("ccbmembers=[%s]\n",SdrTool.ccbmembers);
#endif	/* COMMENT_OUT */

    SDRform =  NULL;
    MrmFetchWidget(HierarchyID, "sDRform", Shell000,
        &SDRform, &MrmWClass);

    MrmCloseHierarchy(HierarchyID);
    XtManageChild(SDRform);
    XtPopup(XtParent(SDRform), XtGrabNone);

    XtAppMainLoop(context);
	exit(0);
} /* end main */
/* end sdrtool.c */
