
#*****************************************************************************
#* $Id: dbtest_driver.mk,v 1.3 1995/01/30 02:56:50 sydd Exp $
#*
#* Makefile Name:   dbtest_driver.mk
#*
#* Description:
#*   Makefile generated by mkmk for dbtest_driver in DBTest_Driver CPC
#*   dbtest_driver is a UNIX executable using cc compiler
#*
#* Notes:
#*   Comment lines with no whitespace between the poundsign and text may
#*   be CodeCenter commands.
#*
#* Original Command Line used to create this makefile (Note that dollar signs,
#* quotes, parentheses of all types must be escaped by preceding them with a
#* backslash when reusing this command). [Note: the #*# at the beginning of
#* the line is a special marker for an automated CM script to find & use -
#* please do not remove it.]:
#*
#*# mkmk -t dbtest_driver -c DBTest_Driver -all
#*
#* Revision History
#*   DATE    S/W ENGINEER     DESCRIPTION OF WORK
#* --------  ---------------  ------------------------------------------------
#* 04/20/94  mkmk             Created from V1.43
#******************************************************************************
#
.SUFFIXES: .o .c .c~ .uid .uil .uil~ .h .h~

# set this to DEBUG=-DDEBUG for Sydd's debug utilities
# set this to DEBUG= for no debug utilities
# THIS HAS NOTHING TO DO WITH SOURCE LEVEL DEBUGGERS LIKE dbg
DEBUG=
#DEBUG=-DDEBUG

# Replace this with location of your local stuff, if needed
LOCALPATH = .

# Locations of common things
COMMONPATH = $(HOME)


# Where to find various helpful utilities
LIST_INCLUDES = find_includes
WHAT_HEADERS = what_headers
CALLS = calls
FIX_CS = fix_cs

# Place -I compiler switches here for the various additional places
# you want the compiler to look for include files specified in double quotes
CINCLUDES = \
 -I$(COMMONPATH)/include \
 -I$(COMMONPATH)/sdrtool

# Local additions for CFLAG options (i.e. -g for debug info left in object)
# These are compiler specific switches only, not including C preprocessor
# flags.
#  - leave debug info in object file for use with source level debuggers
CFLAGS    += -g

# Local additions for C Preprocessor flags - place -D switches here
CPPFLAGS  += \
 $(DEBUG) \
 $(CINCLUDES)

# Where to find libraries and any loader flags (i.e. -s for strip output)
# NOTE: -s negates in the executable what -g profides in the objects
#       Executable can later be stripped of debug things provided by -g compiler
#       switch using strip(1) command - see also ld(1) manpage
LDFLAGS = \
 -L$(COMMONPATH)/utilities

# Libraries needed to compile the target (eg: $(LIBDIR)/otherlib.a -llog))
# -lutilities for SyddWare Generic Utilities
# -lm for libm.a standard system math library (for float/double operations)
# -lMrm for OSF/Motif Resource Manager library
# -lXm for OSF/Motif library
# -lXt for X11R5 Xt Intrinsics library
# -lX11 for X11R5 Xlib library
LDLIBS = \
 -lutilities

# Local additions for UIL compiler
UILFLAGS = \
 -wmd $(MOTIFPATH)/bin/X11/motif.wmd \
 -I/usr/include/Mrm \
 -I/usr/include/uil


#
# General Rules (usually provided in Sun's default.mk file in /usr/include/make)
#
CC=cc

COMPILE.c = \
	$(CC) $(CPPFLAGS) $(CFLAGS) -c
.c.o:
	$(COMPILE.c) -o $@ $<
LINK.c = \
	$(PURIFY) $(PURIFYOPTIONS) $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS)
.c:
	$(LINK.c) -o $@ $< $(LDLIBS)
#
# Typical archiver (library) command
# Library targets should be built as follows:
#  $(ARPREF)$(TARGET).$(AREXT)
#
AR=/usr/bin/ar
ARFLAGS=r
ARPREF=lib
AREXT=a
.c.a:
	$(COMPILE.c) -o $% $<
	$(AR) $(ARFLAGS) $@ $%
	$(RM) $%

RANLIB=ranlib

# misc file ops commands
RM=/bin/rm
MV=/bin/mv
LN=/bin/ln
LNFLAGS=-s


# UIL support
UIL=uil
COMPILE.uil = \
	$(UIL) $(UILFLAGS)
.uil.uid:
	@$(FIX_CS) $<
	$(COMPILE.uil) -o $@ $<
	-@$(LN) $(LNFLAGS) $@ $(LOCALPATH) >/dev/null 2>&1


############################################################
#                                                          #
# INDIVIDUAL PROGRAMER MODIFICATIONS HERE                  #
#                                                          #
# Note:  Source  and object files are lists of files       #
#        separated by spaces.  Use the backslash (\)  for  #
#        lists that span multiple lines.                   #
#                                                          #
############################################################

# Program to make (binary executable or library minus prefix & suffix)
TARGET  =  dbtest_driver$(PURIFY)


# Bindings used by one or more files in TARGET



# Header files for TARGET

INCLUDES.h = \


# Source files for TARGET

SOURCES.c = \
 $(LOCALPATH)/dbtest_driver.c \
 $(LOCALPATH)/printsdr.c \
 $(LOCALPATH)/sqlprintf.c \
 $(LOCALPATH)/get_discrep_rec.c \
 $(LOCALPATH)/insert_discrep_rec.c \
 $(LOCALPATH)/update_discrep_rec.c

SOURCES.uil = \


SOURCES.o = \
	$(SOURCES.c:.c=.o)

OBJECTS = \
	$(SOURCES.o)


SOURCES.uid = \
	$(SOURCES.uil:.uil=.uid)

SOURCES.all = \
	$(SOURCES.c) \
	$(SOURCES.uil)


#
# This is the default object to make (the first colon in the file)
#

$(TARGET): \
 $(INCLUDES.h) \
 $(OBJECTS) g$(TARGET)_include_keys.o $(SOURCES.uid) \
 $(SOURCES.all) g$(TARGET)_include_keys.c
	$(LINK.c) -o $(TARGET) $(OBJECTS) g$(TARGET)_include_keys.o $(LDLIBS)

# Generate a list of functions called by sources in the list
calls:	$(SOURCES.c)
	-@$(RM) -f $(COMMONPATH)/calls/DBTest_Driver.calls $(COMMONPATH)/calls/DBTest_Driver.calls.c
	-@cat $(SOURCES.c) > $(COMMONPATH)/calls/DBTest_Driver.calls.c
	@echo "Call Stack For DBTest_Driver CPC" > $(COMMONPATH)/calls/DBTest_Driver.calls
	@$(CALLS) -X -n -t -f main -c "cc -E" $(CPPFLAGS) $(COMMONPATH)/calls/DBTest_Driver.calls.c >> $(COMMONPATH)/calls/DBTest_Driver.calls
	-@$(RM) -f $(COMMONPATH)/calls/DBTest_Driver.calls.c
	@echo "Rebuilt callstack for DBTest_Driver in $(COMMONPATH)/calls/DBTest_Driver.calls"


# For CodeCenter to load the project
$(TARGET)_project:	$(INCLUDES.h) $(OBJECTS)
	#setopt program_name $(TARGET)
	#setopt load_flags $(CPPFLAGS) $(LDFLAGS)
	#setopt tab_stop 4
	#load $(CPPFLAGS) $(LDFLAGS) $(OBJECTS) $(LDLIBS)
	#link



# Log of what(1) marker lines for all include files used:
# The .c file is dependent upon all include files listed so that
# if one changes, the .c file is regenerated (& thus the .o)
g$(TARGET)_include_keys.c:  $(INCLUDES.h) $(SOURCES.uil)
	-@$(RM) -f g$(TARGET)_include_keys.*
	$(WHAT_HEADERS) -filename g$(TARGET)_include_keys.c \
		$(INCLUDES.h) $(SOURCES.uil) \
		>g$(TARGET)_include_keys.c

# Target to get it to just remake the uid files
uil:	$(SOURCES.uid)



# removes all object files, lintfiles and core if found
clean:
	-$(RM) -f $(OBJECTS) *pure*.o
	-$(RM) -f g*_include_keys.* core a.out

# does clean above PLUS removes the target (executable or library)
clobber:	clean
	-$(RM) -f $(SOURCES.uid)
	-$(RM) -f $(TARGET)


# Provides make format list of sources and include file dependencies by
# examining includes & sources provided for includes using double quotes.
# Use list_includes for direct includes with double quotes
# Use list_all_includes for direct includes with double quotes AND <> brackets
# Use find_includes for direct AND indirect includes with double quotes
list_includes:
	$(LIST_INCLUDES) $(SOURCES.c) | sed -e 's@^\.@$$(LOCALPATH)@' \
		>$(TARGET).includes


# Install target to $(COMMONPATH)/bin
install: $(TARGET)
	@echo "Install $(TARGET) in $(COMMONPATH)/bin"
	@install -m 555 $(TARGET) $(COMMONPATH)/bin
	@echo "Install all .uid files in $(COMMONPATH)/bin/UID"
	@multi_install $(COMMONPATH)/bin/UID $(SOURCES.uid)



# Echo list of all files in INCLUDES.h and SOURCES.all to screen
echofiles:
	@echo $(INCLUDES.h) $(SOURCES.all) | tr ' ' '\012'

#
# Place Source Dependencies Here - no longer provided by mkmk
# Use make -f dbtest_driver.mk list_includes
#  Then check the resulting $(TARGET).includes file before merging it
#  with this makefile as it makes certain assumptions that may not always
#  be correct (hey, mkmk can't read minds, just source).
# Use show_includes $(TARGET) command to see a unique list of .h files
#  included by all files in the makefile after running the above list_includes
#  option.  The list produced by show_includes should match the list in
#  the INCLUDES.h macro in this makefile BEFORE merging the $(TARGET).includes
#  list below.
#
# SOURCE_DEPENDENCIES_HERE--v

$(LOCALPATH)/printsdr.c: $(LOCALPATH)/../printsdr.c
	ln -s $(LOCALPATH)/../printsdr.c

$(LOCALPATH)/sqlprintf.c: $(LOCALPATH)/../sqlprintf.c
	ln -s $(LOCALPATH)/../sqlprintf.c

$(LOCALPATH)/get_discrep_rec.c: $(LOCALPATH)/../get_discrep_rec.c
	ln -s $(LOCALPATH)/../get_discrep_rec.c

$(LOCALPATH)/insert_discrep_rec.c: $(LOCALPATH)/../insert_discrep_rec.c
	ln -s $(LOCALPATH)/../insert_discrep_rec.c

$(LOCALPATH)/update_discrep_rec.c: $(LOCALPATH)/../update_discrep_rec.c
	ln -s $(LOCALPATH)/../update_discrep_rec.c

# SOURCE_DEPENDENCIES_HERE--^
#
# End of dbtest_driver Makefile
# end file : dbtest_driver.mk
