/*****************************************************************************
* @(#)discrep_rep_tbl.sql	1.4 4/26/94 GTE Government Systems Corp.
*
* Classification:  UNCLASSIFIED                   
*
* Project:         CHAMITE
*
* Table Name:      discrep_rep_tbl.sql
*
* Description:    
*   This code creates the DISCREP_REP table which will be used to by CM to 
*   track discrepancy reports.
*
* Notes:           
*
* Revision History
*   DATE    S/W ENGINEER     DESCRIPTION OF WORK
* --------  ---------------  ------------------------------------------------
* 09-22-93  R.K.Montgomery   Initial coding.
* 10-15-92  R.K.Montgomery   Made FUNCTION nullable.
* 10-22-93  R.K.Montgomery   Added TROUBLE_AREA field.
* 04/26/94  J.R.(Sydd)Souza  Changed FUNCTION to THREAD & beefed comments
******************************************************************************/

create table DISCREP_REP    

(NORMAL_ID        char(6)  not null,      /*N#####, unique, # is 0...9 */
 ASSIGNED_ID      char(6)  not null,      /*N#####, normal(matches field above)
                                            S#####, software           
                                            H#####, hardware           
                                            D#####, documentation      
                                            T#####, tool     or        
                                            V#####, vendor             */
 TITLE            varchar(50)  not null,  /* whatever                  */
 STATUS           smallint     not null,  /* 1 - New/CCB1, 2 - Assess,
                                             3 - Assigned, 4 - CCB2, 
                                             5 - Resolved, 6 - Rejected,
                                             7 - CM Eval,  8 - Promote */
 PRIORITY         smallint     not null,  /* 1 - highest priority,
                                             2 - requirement conflict,
                                             3 - functional bug,
                                             4 - minor problem,
                                             5 - out of scope          */
 ORIGIN_DATE      smalldatetime  not null, /* mmm dd yyyy HH:MM        */
 ORIGINATOR       varchar(25)    not null,
 ASSIGN_DATE      smalldatetime      null, /* mmm dd yyyy HH:MM        */
 ASSIGNED_TO      varchar(25)        null,
 DUE_DATE         smalldatetime      null, /* mmm dd yyyy HH:MM        */
 CLOSE_DATE       smalldatetime      null, /* mmm dd yyyy HH:MM        */
 CPC              char(2)        not null, /* 2 char CPC mnemonic      */
 THREAD           varchar(30)        null, /* thread                   */
 TIME_TO_COMPLETE int                null, /* in hundreths of hours    */
 TRANSITION_DATE  smalldatetime      null, /* mmm dd yyyy HH:MM        */
 TROUBLE_AREA     varchar(75)    not null  /* UNKNOWN or user specified*/
)
