#ifndef	lint
static char sccsid[] = "$Id: edit_file_callback.c,v 1.1 1995/01/24 05:16:42 sydd Exp $ SyddWare";
#endif
/*****************************************************************************
* Classification:    Unclassified
*
* Project:           SDRTOOL
*
* Module Name:       edit_file_callback.c
*
* Description:
*   
*
* Calling Sequence:
*   
*
*   Inputs:
*       None
*
*   Outputs:
*       None
*
*   Returns:
*       None
*
* Error Conditions and Actions:
*   N/A
*
* Side Effects:
*   N/A
*
* Limitations:
*   N/A
*
* Notes:
*   N/A
*
* Revision History
*   DATE    S/W ENGINEER     DESCRIPTION OF WORK
* --------  ---------------  ------------------------------------------------
*
******************************************************************************/
#include "sdr_.h"	/* for this prototype */
#include "sdr_g.h"	/* for globals */

void
edit_file_callback(w, which_one, call)
	Widget w;
	int *which_one;
	XmPushButtonCallbackStruct *call;
{
	char 		*argv[256];
				/* should be able to take filename as single parm */
	char		*editcommand;
	char		*extension = (char *)0;
	char		*idptr;
	pid_t		process_pid; /* needs to be one of 9 entries in a table */
	int			icnt;
	int			notperform = -1;
	int			notvalidate = -1;
	int			table_entry;
	char		originalpath[256];
	char		editfilename[256];
	char		system_command[256];
	ID_CODE_T	id;
	SDR_T		sdr;

	/* get XmNuserData from Widget w to figure out extension */
	XtVaGetValues(w, XmNuserData, &extension, NULL);

	for (table_entry=0; extension && Process_table[table_entry].extension &&
		strcmp(Process_table[table_entry].extension, extension); ++table_entry)
		DO_NOTHING;

	if (!extension || !Process_table[table_entry].extension)
	{
		/* !PING! bad extension for some reason */
		if (!extension)
		{
			BEEP_MESSAGE("Bad extension <null>");
		}
		else
		{
			sprintf(originalpath,"Extension not found [%s]",
				extension);
			BEEP_MESSAGE(originalpath);
		}
		return;
	}
	else if (Process_table[table_entry].pid != -1)
	{
		/* !PING! already editing that one */
		BEEP_MESSAGE("That file is already being modified");
		return;
	}

	notvalidate = strcmp(extension,VALIDATED_EXT);
	notperform = strcmp(extension,PERFORMED_EXT);

	/*	Yank id from k_idtextField */
	if (!strcmp(extension,HELP_FILE_EXT))
		idptr = HELP_FILE_NAME;
	else
	{
		idptr = XmTextFieldGetString( Widget_list[ k_idtextField ] );
		if (!idptr || emptyline(idptr))
		{
			/* !PING! gotta choose */
			BEEP_MESSAGE("You must first fill in the ID or NEW");
			return;
		}
		s_toupper(idptr);
		strip_whitespace(idptr);
		if (((!notvalidate || !notperform) &&
			!isvalidid(idptr)) ||
			(notvalidate && notperform &&
			 !strstr(idptr,"NEW") && !isvalidid(idptr)))
		{
			/* !PING! gotta choose a valid one! */
			BEEP_MESSAGE("Invalid SDR ID for this function");
			return;
		}
	}

	/*
	**	If id is NEW, use pid.
	**	Otherwise if id != ORIGINAL_PREFIX (or lowercase version)
	**	retrieve current record, if any, from database into sdr.
	*/
	
	if (!strcmp(idptr,HELP_FILE_NAME))
	{
		strcpy(id,HELP_FILE_NAME);
		sprintf(originalpath,"%s/%s", SdrTool.sdrpath, extension);
		sprintf(editfilename,"%s/%s%s", Tempdir,id, extension);
		if (access(editfilename,NOTEXIST))
		{
			CHECK_AND_REPLACE(Tempdir, id, originalpath, id, extension, FALSE);
		}
	}
	else if (strstr(idptr,"NEW") || emptyline(idptr))
		sprintf(id,"%d",getpid());
	else
	{
		if (idptr[0] == ORIGINAL_PREFIX ||
			toupper(idptr[0]) == ORIGINAL_PREFIX)
		{
			strncpy(sdr.id[0],idptr,sizeof(ID_CODE_T));
			sdr.id[0][sizeof(ID_CODE_T)-1] = '\0';
			sdr.id[1][0] = '\0';
		}
		else
		{
			sdr.id[0][0] = '\0';
			strncpy(sdr.id[1],idptr,sizeof(ID_CODE_T));
			sdr.id[1][sizeof(ID_CODE_T)-1] = '\0';
		}
		get_current_record(&sdr);	/* will reset id[0] to null if nf */
		strcpy(id,sdr.id[0]);
		sprintf(originalpath,"%s/%s", SdrTool.sdrpath, extension);
		if (!strcmp(extension,VALIDATED_EXT) ||
			!strcmp(extension,PERFORMED_EXT))
		{
			sprintf(editfilename,"%s/%s%s", originalpath, id, extension);
			if (access(editfilename,NOTEXIST))
			{
				sprintf(originalpath,"File %s%s does not exist",
					id, extension);
				BEEP_MESSAGE(originalpath);
				return;
			}
		}
		sprintf(editfilename,"%s/%s%s", Tempdir, id, extension);

		if (!notvalidate || !notperform)
			remove(editfilename);	/* replace it every time */

		if (access(editfilename,NOTEXIST))
		{
			CHECK_AND_REPLACE(Tempdir, id, originalpath, id, extension, FALSE);
		}
	}
	if (strcmp(idptr,HELP_FILE_NAME))
		XtFree(idptr);

	strncpy(Process_table[table_entry].id, id,
		sizeof(Process_table[table_entry].id)-1);
	Process_table[table_entry].id[sizeof(Process_table[table_entry].id)-1] =
		'\0';

	if (!(editcommand = (char *)getenv(SDREDITOR)))
		editcommand = "/usr/local/bin/xvi";	/* sorry but vi is harder in X */

	sprintf(system_command,"%s %s/%s%s", editcommand, Tempdir, id, extension);
	DIAG1(edit_file_callback:,system_command,s);
	/* break up parms by whitespace */
	for (icnt=0; icnt<256; ++icnt)
	{
		if (!icnt)
			argv[icnt] = strtok(system_command," \t");
		else
			argv[icnt] = strtok(NULL," \t");
		if (!argv[icnt])
			break;
	}
	argv[255] = (char *)0;

	/*
	**	Fork off an exact copy of this process - the copy will gain control
	**	from where the fork command left off with commsproc_id set to 0
	**	(meaning it's the child).  The original parent will get back a pid > 0
	*/
	switch ( process_pid = fork ())
	{
	    case -1: 
			errno = ENOEXEC;
			return;
			/* break; */

	    case 0: 
			/*
			**	Forked process gains control of the process here, so
			**	exec the real process (control will not return from the
			**	exec call unless it fails).
			*/
			errno = ESRCH; /* for lack of anything better */
			execvp (argv[0], argv);
			perror
				("sdrtool: Should not have but returned from execvp on edit.");
			/* no-one to return to so just terminate */
			exit(errno);
			/* break; */

	    default: 
			/* parent regains control here */
			Process_table[table_entry].pid = process_pid;	/* save it */
			break;
	}
	return;
}
