#ifndef	lint
static char rcsid[] = "$Id: extract_from_window.c,v 1.8 1995/04/09 00:48:58 sydd Exp $ SyddWare";
#endif
/*****************************************************************************
* Classification:    Unclassified
*
* Project:           SDRTOOL
*
* Module Name:       extract_from_window.c
*
* Description:
*
*
* Calling Sequence:
*
*
*   Inputs:
*       None
*
*   Outputs:
*       None
*
*   Returns:
*       None
*
* Error Conditions and Actions:
*   N/A
*
* Side Effects:
*   N/A
*
* Limitations:
*   N/A
*
* Notes:
*   N/A
*
* Revision History
*   DATE    S/W ENGINEER     DESCRIPTION OF WORK
* --------  ---------------  ------------------------------------------------
*
******************************************************************************/
#include "sdr_.h"      /* for Function prototype etc. */

/*
** For some reason MOTIF_2 (which I run at home) runs afoul when XtFree-ing
** stuff traditionally freeable.  Gotta check the manuals if and when I get
** them.  Meanwhile, in Motif V2 we may be awfully leaky.  Better leaks than
** crashes eh?
*/
#define	MOTIF_2

BOOLEAN
extract_from_window(sdr,isnew,previous_state,idfilename)
	SDR_T *sdr;
	BOOLEAN *isnew;
	STATUS_T *previous_state;
	char	**idfilename;
{
	char				*hundredstr;
	char				*text;
	char				*this_id = (char *)0;
	XmString			origstring;
	XmStringContext		context;
	XmStringCharSet		charset;
	XmStringDirection	direction;
	Boolean				separator;
	int					hundredths, index;
	int         		wholepart;
	int       			wholestr;
	ID_CODE_T   		last_id;
	char				tempstring[20];
	ID_PREFIX_T 		sdrtype;
	
	if (!(this_id = XmTextFieldGetString(Widget_list[ k_idtextField ])))
	{
		XBell(XtDisplay(Widget_list[ k_maildrawnButton ]),50);
		return TRUE;
	}
	else if (emptyline(this_id))
        strcpy(last_id, "NEW");
    else
	{
        strncpy(last_id, this_id, sizeof(ID_CODE_T));
        last_id[sizeof(ID_CODE_T)-1] = '\0';
	}
#ifndef	MOTIF_2
    XtFree(this_id);
#endif	/* MOTIF_2 */


	/* If it's NEW, get next one from config file then 1-up it. */
	s_toupper(last_id);
	strip_whitespace(last_id);
	if (strstr(last_id,"NEW"))
	{
		*isnew = TRUE;
		/* do the above here filling last_id with new id value */
		if (lockout_idfile(idfilename))
		{
			*isnew = FALSE;
			*idfilename = (char *)0;
			return TRUE;
		}

		if (get_next_id(ORIGINAL_PREFIX,last_id,FALSE))
		{
			/* Oops, cannot get new one, sorry - !PING! the user */
			XBell(XtDisplay(Widget_list[ k_maildrawnButton ]),50);
			fprintf(stderr,
				"Cannot get next %c-type id from .assign file",
				ORIGINAL_PREFIX);
			*isnew = FALSE;	/* force it back */
			unlock_idfile(*idfilename);
			*idfilename = (char *) 0;
			return TRUE;
		}
	}
	else	/* validate it & set last_id to it */
	{
		if (isvalidid(last_id))
		{
			*isnew = FALSE;
			/* lowercase version: s_tolower(last_id); */
		}
		else
		{
			/* Oops, not valid, sorry - !PING! the user */
			XBell(XtDisplay(Widget_list[ k_maildrawnButton ]),50);
			*isnew = FALSE;	/* force it back */
			return TRUE;
		}
	}

	memset(sdr, (int)'\0', sizeof(SDR_T));
	/* retrieve current record, if any, from database into (*sdr). */
	if (!*isnew)
	{
		strcpy((*sdr).id[0],last_id);
		get_current_record(&(*sdr));	/* will reset id[0] to null if nf */
	}
	*previous_state = (*sdr).status;

	/* fill (*sdr) record */
	if (emptyline((*sdr).id[0]))	/* not in database */
	{
		strcpy((*sdr).id[0],last_id);
		strcpy((*sdr).id[1],last_id);
	}
	/*
	**	Replace labels of ID Drawn Buttons
	*/
	sprintf(tempstring,"Orig #: %s",(*sdr).id[0]);
	origstring = XmStringCreateLtoR(tempstring, XmFONTLIST_DEFAULT_TAG);

    XtVaSetValues(Widget_list[k_masteriddrawnButton],
        XmNlabelString, origstring, NULL);

	XmStringFree(origstring);

	sdrtype = ORIGINAL_PREFIX;
	if (!strcmp(username, SdrTool.cmaccountname))
	{
    	XtVaGetValues(Widget_list[k_catiddrawnButton],
          	XmNlabelString, &origstring, NULL);
    	XmStringInitContext(&context,origstring);
    	XmStringGetNextSegment(context,
          	&text, &charset, &direction, &separator);
    	XmStringFreeContext(context);
    	XmStringFree(origstring);
		if (!strcmp(&text[8],"S#####"))
			sdrtype = SOFTWARE_PREFIX;
		else if (!strcmp(&text[8],"H#####"))
			sdrtype = HARDWARE_PREFIX;
		else if (!strcmp(&text[8],"D#####"))
			sdrtype = DOCUMENTATION_PREFIX;
		else if (!strcmp(&text[8],"T#####"))
			sdrtype = TOOL_PREFIX;
		else if (!strcmp(&text[8],"V#####"))
			sdrtype = VENDOR_PREFIX;

		if (sdrtype != ORIGINAL_PREFIX)
		{
			strcpy(tempstring,text);
			strcpy((*sdr).id[1],&text[8]);
		}
		else
			sprintf(tempstring,"Perm #: %s",(*sdr).id[1]);
	}
	else
		sprintf(tempstring,"Perm #: %s",(*sdr).id[1]);
	
	origstring = XmStringCreateLtoR(tempstring, XmFONTLIST_DEFAULT_TAG);

	XtVaSetValues(Widget_list[k_catiddrawnButton],
		XmNlabelString, origstring,
		NULL);

	XmStringFree(origstring);

	/*
	**	Replace unsigned long hours; member which is stored as
	**	hundredths of hours: 1 hour=100 with value extracted to 2
	**	decimal places from k_hourstextField
	*/
	if (*isnew ||
		!strcmp(username,(*sdr).originator) ||
		strstr((*sdr).co_assignee,username) ||
		!strcmp(username,(*sdr).assigned_to) ||
		!strcmp(username,SdrTool.cmaccountname))
	{
		this_id =
			XmTextFieldGetString( Widget_list[ k_hourstextField ] );
		strcpy(tempstring,this_id);
#ifndef	MOTIF_2
		XtFree(this_id);
#endif	/* MOTIF_2 */

		strip_whitespace(tempstring);
		if (!emptyline(tempstring))
		{
			if (isdigit(tempstring[0]))
				sscanf(tempstring,"%d",&wholepart);
			else
				wholepart = 0;
			if ((hundredstr = strchr(tempstring,'.')) &&
				strlen(hundredstr) > 1)
			{
				/* either 2 or 3 chars - if 2 append 0 to get right value */
				if (strlen(hundredstr) == 2)
					strcat(hundredstr,"0");
				sscanf(hundredstr,".%d", &hundredths);
			}
			else	/* no decimal point or no chars following it */
				hundredths = 0;
			(*sdr).hours = wholepart * 100 + hundredths;
		}
		else
			(*sdr).hours = 0;
	}

	/*
	**	Replace STATUS_T status; member as rules apply from selection
	**	in k_statusradioBox or toggle selected: k_assesstoggleButton,
	**	k_assignedtoggleButton, k_ccb2toggleButton, k_newtoggleButton,
	**	k_rejectedtoggleButton, or k_resolvedtoggleButton.
	**	k_cmevaltoggleButton, or k_promotetoggleButton.
	*/
	if (*isnew)
		(*sdr).status = NEW_CCB1;
	else if (!strcmp(username,(*sdr).originator) ||
		!strcmp(username,(*sdr).assigned_to) ||
		!strcmp(username,SdrTool.cmaccountname))
	{
		if (XmToggleButtonGetState( Widget_list[ k_assesstoggleButton ]))
			(*sdr).status = ASSESS;
		else if (XmToggleButtonGetState(
					Widget_list[ k_assignedtoggleButton ]))
			(*sdr).status = ASSIGNED;
		else if (XmToggleButtonGetState(
					Widget_list[ k_ccb2toggleButton ]))
			(*sdr).status = CCB2;
		else if (XmToggleButtonGetState(
					Widget_list[ k_resolvedtoggleButton ]))
			(*sdr).status = RESOLVED;
		else if (XmToggleButtonGetState(
					Widget_list[ k_rejectedtoggleButton ]))
			(*sdr).status = REJECTED;
		else if (XmToggleButtonGetState(
					Widget_list[ k_cmevaltoggleButton ]))
			(*sdr).status = CMEVAL;
		else if (XmToggleButtonGetState(
					Widget_list[ k_promotetoggleButton ]))
			(*sdr).status = PROMOTE;
		else	/* default */
			(*sdr).status = NEW_CCB1;
	}

	/*
	**	Get string date from k_originatedatetextField into
	**	DATE_STRING_T originated; validate it & correct
	*/
	if (*isnew)
	{
		/* set it first */
		CURRENT_DATE((*sdr).originated);
		XmTextFieldSetString( Widget_list[ k_originatedatetextField ],
			(*sdr).originated);
	}
	else if (!strcmp(username,SdrTool.cmaccountname))
	{
		this_id = XmTextFieldGetString(
					Widget_list[ k_originatedatetextField ]);
		strncpy((*sdr).originated,this_id,sizeof((*sdr).originated));
		(*sdr).originated[sizeof((*sdr).originated)-1] = '\0';
#ifndef	MOTIF_2
		XtFree(this_id);
#endif	/* MOTIF_2 */
	}

	/*
	**	Get string date from k_assigndatetextField into
	**	DATE_STRING_T assigned; validate it & correct
	*/
	if (!strcmp(username,SdrTool.cmaccountname))
	{
		this_id = XmTextFieldGetString(
					Widget_list[ k_assigndatetextField ]);
		strncpy((*sdr).assigned,this_id, sizeof((*sdr).assigned));
		(*sdr).assigned[sizeof((*sdr).assigned)-1] = '\0';
#ifndef	MOTIF_2
		XtFree(this_id);
#endif	/* MOTIF_2 */
	}

	/*
	**	Get string date from k_duedatedrawnButton into
	**	DATE_STRING_T due; validate it & correct
	*/
	if (!strcmp(username,SdrTool.cmaccountname))
	{
    	XtVaGetValues(Widget_list[k_duedatedrawnButton],
          	XmNlabelString, &origstring, NULL);
    	XmStringInitContext(&context,origstring);
    	XmStringGetNextSegment(context,
          	&text, &charset, &direction, &separator);
    	XmStringFreeContext(context);
    	XmStringFree(origstring);
		strncpy((*sdr).due, text, sizeof((*sdr).due));
		(*sdr).due[sizeof((*sdr).due)-1] = '\0';
		strip_whitespace((*sdr).due);
#ifndef	MOTIF_2
		XtFree(this_id);
#endif	/* MOTIF_2 */
	}

	/*
	**	Get string date from k_closedatetextField into
	**	DATE_STRING_T closed; validate it & correct
	*/
    if (!strcmp(username,SdrTool.cmaccountname))
    {
		this_id = XmTextFieldGetString(
					Widget_list[ k_closedatetextField ]);
		strncpy((*sdr).closed,this_id, sizeof((*sdr).closed));
		(*sdr).closed[sizeof((*sdr).closed)-1] = '\0';
#ifndef	MOTIF_2
		XtFree(this_id);
#endif	/* MOTIF_2 */
	}

	/*
	**	Replace char title[TITLE_SIZE +1]; from k_titletextField
	*/
    if (*isnew || !strcmp(username,SdrTool.cmaccountname))
    {
		this_id = XmTextFieldGetString( Widget_list[ k_titletextField ]);
		strncpy((*sdr).title,this_id, sizeof((*sdr).title));
		(*sdr).title[sizeof((*sdr).title)-1] = '\0';
#ifndef	MOTIF_2
		XtFree(this_id);
#endif	/* MOTIF_2 */

		/* strip out extraneous quotes & things that SQL may choke on */
		for (this_id=(*sdr).title;*this_id;++this_id)
			if (*this_id == 0x22 ||	/* double quote */
				*this_id == 0x27 ||	/* single quote */
				*this_id == 0x60)	/* backquote */
				*this_id = ' ';		/* replace them with space */

	}

	/*
	**	Replace char originator[ORIGINATOR_SIZE +1]; from
	**	k_originatortextField
	*/
	if (*isnew || !strcmp(username,SdrTool.cmaccountname))
	{
		this_id = XmTextFieldGetString(
				Widget_list[ k_originatortextField ]);
		if (*isnew || !this_id || emptyline(this_id))
		{ /* always replace originator if new or empty */
			strncpy((*sdr).originator, username, sizeof((*sdr).originator));
			(*sdr).originator[sizeof((*sdr).originator)-1] = '\0';
			XmTextFieldSetString(Widget_list[ k_originatortextField ],
				(*sdr).originator);
		}
		else
		{
			strncpy((*sdr).originator,this_id, sizeof((*sdr).originator));
			(*sdr).originator[sizeof((*sdr).originator)-1] = '\0';
		}
#ifndef	MOTIF_2
		XtFree(this_id);
#endif	/* MOTIF_2 */
	}

	/*
	**	Replace char assigned_to[ASSIGNED_SIZE +1]; from
	**	k_assignedtextField
	*/
	if (!strcmp(username,SdrTool.cmaccountname))
	{
		this_id = XmTextFieldGetString(
					Widget_list[ k_assignedtextField ]);
		strncpy((*sdr).assigned_to,this_id, sizeof((*sdr).assigned_to));
		(*sdr).assigned_to[sizeof((*sdr).assigned_to)-1] = '\0';
#ifndef	MOTIF_2
		XtFree(this_id);
#endif	/* MOTIF_2 */
	}

	/*
	**	Replace char co_assignee[ASSIGNED_SIZE +1]; from
	**	k_co_assigneetextField
	*/
	if (!strcmp(username,SdrTool.cmaccountname) ||
		!strcmp(username,(*sdr).assigned_to))
	{
		this_id = XmTextFieldGetString(
					Widget_list[ k_co_assigneetextField ]);
		strncpy((*sdr).co_assignee,this_id, sizeof((*sdr).co_assignee));
		(*sdr).co_assignee[sizeof((*sdr).co_assignee)-1] = '\0';
#ifndef	MOTIF_2
		XtFree(this_id);
#endif	/* MOTIF_2 */
	}

	/*
	**	Replace char cpc_mnemonic[CPC_CODE_SIZE +1]; from
	**	the XmNuserData value of the current selection PushButton of the
	**	k_cpcoptionMenu or k_cpcpulldownMenu
	*/
	if (*isnew ||
        !strcmp(username,(*sdr).originator) ||
        !strcmp(username,(*sdr).assigned_to) ||
		!strcmp(username,SdrTool.cmaccountname))
	{
		if (XmToggleButtonGetState( Widget_list[ k_softtoggleButton ]))
		{
			strncpy((*sdr).cpc_mnemonic,"ST",
					sizeof((*sdr).cpc_mnemonic));
			(*sdr).cpc_mnemonic[sizeof((*sdr).cpc_mnemonic)-1] = '\0';

			XtVaGetValues (Widget_list[ k_styperadioBox ], XmNuserData,
				 &index, NULL);
        	strncpy((*sdr).trouble_area, CPC_table[index].name,
						 sizeof((*sdr).trouble_area));
        	(*sdr).trouble_area[sizeof((*sdr).trouble_area)-1] = '\0';
#ifndef	MOTIF_2
    		XtFree(this_id);
#endif	/* MOTIF_2 */
		}
		else if (XmToggleButtonGetState( Widget_list[ k_hardtoggleButton ]))
		{
			strncpy((*sdr).cpc_mnemonic,"HT",
					sizeof((*sdr).cpc_mnemonic));
			(*sdr).cpc_mnemonic[sizeof((*sdr).cpc_mnemonic)-1] = '\0';
			XtVaGetValues (Widget_list[ k_htyperadioBox], XmNuserData,
				 &index, NULL);
        	strncpy((*sdr).trouble_area, hardware_table[index].name,
						 sizeof((*sdr).trouble_area));
        	(*sdr).trouble_area[sizeof((*sdr).trouble_area)-1] = '\0';
#ifndef	MOTIF_2
    		XtFree(this_id);
#endif	/* MOTIF_2 */
		}
		else if (XmToggleButtonGetState( Widget_list[k_documenttoggleButton ]))
		{
			strncpy((*sdr).cpc_mnemonic,"DT",
					sizeof((*sdr).cpc_mnemonic));
			(*sdr).cpc_mnemonic[sizeof((*sdr).cpc_mnemonic)-1] = '\0';
			XtVaGetValues (Widget_list[ k_dtyperadioBox ], XmNuserData,
				 &index, NULL);
        	strncpy((*sdr).trouble_area, document_table[index].name,
						 sizeof((*sdr).trouble_area));
        	(*sdr).trouble_area[sizeof((*sdr).trouble_area)-1] = '\0';
#ifndef	MOTIF_2
    		XtFree(this_id);
#endif	/* MOTIF_2 */
		}
		else if (XmToggleButtonGetState( Widget_list[ k_tooltoggleButton ]))
		{
			strncpy((*sdr).cpc_mnemonic,"TT",
					sizeof((*sdr).cpc_mnemonic));
			(*sdr).cpc_mnemonic[sizeof((*sdr).cpc_mnemonic)-1] = '\0';
			this_id = XmTextFieldGetString(
					Widget_list[ k_tooltextField ]);
        	strncpy((*sdr).trouble_area, this_id,
						 sizeof((*sdr).trouble_area));
        	(*sdr).trouble_area[sizeof((*sdr).trouble_area)-1] = '\0';
#ifndef	MOTIF_2
    		XtFree(this_id);
#endif	/* MOTIF_2 */
		}
		else if (XmToggleButtonGetState( Widget_list[ k_vendortoggleButton ]))
		{
			strncpy((*sdr).cpc_mnemonic,"VT",
					sizeof((*sdr).cpc_mnemonic));
			(*sdr).cpc_mnemonic[sizeof((*sdr).cpc_mnemonic)-1] = '\0';
			XtVaGetValues (Widget_list[ k_vtyperadioBox ], XmNuserData,
				 &index, NULL);
        	strncpy((*sdr).trouble_area, vendor_table[index].name,
						 sizeof((*sdr).trouble_area));
        	(*sdr).trouble_area[sizeof((*sdr).trouble_area)-1] = '\0';
#ifndef	MOTIF_2
    		XtFree(this_id);
#endif	/* MOTIF_2 */
		}
		else if (XmToggleButtonGetState( Widget_list[ k_unknowntoggleButton ]))
		{
			strncpy((*sdr).cpc_mnemonic,"UT",
					sizeof((*sdr).cpc_mnemonic));
			(*sdr).cpc_mnemonic[sizeof((*sdr).cpc_mnemonic)-1] = '\0';
        	strncpy((*sdr).trouble_area, "Unknown",
						 sizeof((*sdr).trouble_area));
        	(*sdr).trouble_area[sizeof((*sdr).trouble_area)-1] = '\0';
#ifndef	MOTIF_2
    		XtFree(this_id);
#endif	/* MOTIF_2 */
		}
		else
		{
			XBell(XtDisplay(Widget_list[k_unknowntoggleButton]),50);
			strcpy((*sdr).cpc_mnemonic,"UT");
    		XmToggleButtonSetState(Widget_list[	k_unknowntoggleButton ],
				True, True );  	 				
        	strncpy((*sdr).trouble_area, "Unknown",
						 sizeof((*sdr).trouble_area));
		}
	}

	/*
	**	Replace char thread[THREAD_SIZE +1]; from
	**	k_threadtextField
	*/
	if (*isnew ||
        !strcmp(username,(*sdr).originator) ||
        !strcmp(username,(*sdr).assigned_to) ||
		!strcmp(username,SdrTool.cmaccountname))
	{
		this_id = XmTextFieldGetString(
					Widget_list[ k_threadtextField ]);
		strncpy((*sdr).thread,this_id, sizeof((*sdr).thread));
		(*sdr).thread[sizeof((*sdr).thread)-1] = '\0';
#ifndef	MOTIF_2
		XtFree(this_id);
#endif	/* MOTIF_2 */

		/* strip out extraneous quotes & things that SQL may choke on */
		for (this_id=(*sdr).thread;*this_id;++this_id)
			if (*this_id == 0x22 ||	/* double quote */
				*this_id == 0x27 ||	/* single quote */
				*this_id == 0x60)	/* backquote */
				*this_id = ' ';		/* replace them with space */
	}

	/*
	**	Replace unsigned char priority;	from
	**	value of the k_priorityscale
	*/
	if (*isnew ||
		!strcmp(username,SdrTool.cmaccountname))
	{
		XmScaleGetValue( Widget_list[ k_priorityscale ], &wholestr);
		(*sdr).priority = wholestr;
	}

	/* refresh screen with things as extracted (some may not have been) */
	FILL_IT_IN(*sdr);
	return FALSE;
}
