#ifndef	lint
static char sccsid[] = "$Id: get_next_id.c,v 1.1 1995/01/24 05:16:42 sydd Exp sydd $ SyddWare";
#endif
/*****************************************************************************
* Classification:    Unclassified
*
* Project:           SDRTOOL
*
* Module Name:       get_next_id.c
*
* Description:
*   
*
* Calling Sequence:
*   
*
*   Inputs:
*       None
*
*   Outputs:
*       None
*
*   Returns:
*       None
*
* Error Conditions and Actions:
*   N/A
*
* Side Effects:
*   N/A
*
* Limitations:
*   N/A
*
* Notes:
*   N/A
*
* Revision History
*   DATE    S/W ENGINEER     DESCRIPTION OF WORK
* --------  ---------------  ------------------------------------------------
*
******************************************************************************/
#include <Xm/Xm.h>
#include "sdr_.h"
#include "sdrtags.h"

BOOLEAN	get_next_id(prefix, next_id, saveit)
	ID_PREFIX_T prefix;
	ID_CODE_T next_id;
	BOOLEAN	saveit;	/* if TRUE, rewrite after 1-upping */
{	/* returns FALSE if next_id provided, TRUE with errno set otherwise */
	FILE	*idfile = (FILE *)0;
	char	*idfilename = (char *)0;
	long	fpos;
	int		bpos;
	int		value;
	char	buffer[80];	/* for line reads from file */
	char	tempfilename[256];	/* for sdr number file */
	char	fmt[8];			/* %#.#d */
	char	tmp[20];		/* temp holding string */
	char	prefixstring[sizeof(ID_PREFIX_T)+1];
	BOOLEAN	notfound = FALSE;

	if (!next_id)
	{
		errno = EINVAL;
		return TRUE;
	}

	sprintf(tempfilename,"%s/%s", SdrTool.sdrpath,SdrTool.sdridfile);
	idfilename = tempfilename;

	prefixstring[0] = (char)prefix;
	prefixstring[1] = '\0';

	/* open for update (read/write) */
	if (!access(idfilename,NOTWRITABLE) &&
		(idfile = fopen(idfilename,"r+")))
	{
		fpos = 0;
		notfound = TRUE;
		while (fgets(buffer, sizeof(buffer), idfile) && notfound)
		{
			if (!emptyline(buffer) &&
				(bpos = firstword(buffer, prefixstring)) != -1)
			{	/* found it */
				/* that's the one we return */
				strncpy((char *)next_id,&buffer[bpos],sizeof(ID_CODE_T));
				next_id[sizeof(ID_CODE_T)-1] = '\0';

				if (saveit)
				{
					/* now get the value & one-up it */
					++bpos;	/* skip prefix */
					sscanf(&buffer[bpos],"%d",&value);
					++value;

					/* check value for proper range & reset to 0 if too big */
					sprintf(tmp,"%d",value);
					if (strlen(tmp) > sizeof(ID_CODE_T)-1)
						value = 0;	/* may want to "ping" somebody */

					/* build format string for sprintf */
					sprintf(fmt,"%%%d.%dd", sizeof(ID_CODE_T)-2,
						sizeof(ID_CODE_T)-2);

					/* replace incremented value */
					sprintf(tmp,fmt,value);
					strncpy(&buffer[bpos],tmp,sizeof(ID_CODE_T)-2);

					/* backup to 1st digit after prefix */
					fpos = ftell(idfile) - (long)strlen(buffer) + (long)bpos;
					fseek(idfile, fpos, SEEK_SET);

					/* replace just those characters */
					fwrite(&buffer[bpos],sizeof(ID_CODE_T)-2,1,idfile);
				}
				notfound = FALSE;
			}
		}
		fclose(idfile);
		if (notfound)
		{
			BEEP_MESSAGE("Bad IDFile ID prefix");
			errno = EINVAL;	/* for lack of anything better */
			return TRUE;
		}
		else
			return FALSE;	/* SUCCESSFUL! */
	}
	else /* could not open file */
	{
		/* save errno as set by fopen failure */
		value = errno;
		BEEP_MESSAGE("Bad IDFile ID prefix");
		errno = value; /* put it back */
		return TRUE;
	}
}
