/*****************************************************************************
* @(#)generi_t.h	1.4 3/14/94 SyddWare
*
* Classification:  Unclassified
*
* Project:         SDRTOOL
*
* Binding Name:    generi_t.h
*
* Description:
*	This header file provides the typedefs for general SDRTOOL types.
*
* Notes:
*	N/A
*
* Revision History
*   DATE    S/W ENGINEER     DESCRIPTION OF WORK
* --------  ---------------  ------------------------------------------------
* 04/01/93  J.R.(Sydd)Souza  Created
******************************************************************************/
#ifndef GENERI_T_H
#	define GENERI_T_H

typedef int FILEHANDL;      /* for UNIX fileio using read/write */

typedef char CHAR ;         /* A one byte character*/
typedef CHAR *PCHAR ;       /* A pointer to a one byte character*/
typedef CHAR *PSZ ;         /* A pointer to a null terminated character string*/
							/* see also NULLP constant in generi.h */

typedef unsigned char UCHAR ;	/* A one byte unsigned character*/
typedef UCHAR *PUCHAR ;        	/* A pointer to a one byte unsigned character*/

typedef short SHORT ;           /* A two byte (at least) integer*/
typedef SHORT *PSHORT ;         /* A pointer to a two byte (at least) integer*/

typedef unsigned short USHORT ; /* A two byte (at least) unsigned integer*/
typedef USHORT *PUSHORT ;		/*
								** A pointer to a two byte (at least) unsigned
								**	integer
								*/

typedef long LONG ;             /* A four byte integer*/
typedef LONG *PLONG ;           /* A pointer to a four byte integer*/

typedef unsigned long ULONG ;   /* A four byte unsigned integer*/
typedef ULONG *PULONG ;         /* A pointer to a four byte integer*/

/*
**	Boolean holding TRUE or FALSE only
**		Note: BOOL is in conflict with a type in Sybase's sybfront.h
**	which some of us MUST use.  To avoid requiring everyone to include
**	sybfront.h just to get BOOL, I change BOOL and PBOOL to BOOLEAN &
**	PBOOLEAN - JRS 6/7/93
*/
typedef int BOOLEAN;    		 /* use most efficient size */
typedef BOOLEAN *PBOOLEAN ;      /* A pointer to a Boolean variable*/

typedef short int FLAG;    		/* use most efficient size (TRUE and FALSE)*/
typedef FLAG *PFLAG ; 	     	/* A pointer to a FLAG variable*/

/*
**  General time/date format for anything destined for the database
**  Routines in c22 should be defined to manipulate various other
**  formats to/from as needed, and are listed here:
**  date_time_string() - takes DATE_TIME_T ptr returns string
**  TBD
*/
typedef struct  DATE_TIME_STRUCT
{
    unsigned char   year;   /* does not include century */
                            /*
                            ** Assume if >= 92, century is 1900,
                            ** and if < 92, century is 2000.
                            ** [This assumption is based upon
                            ** the fact that this system did not exist prior
                            ** to 1992 and will no longer exist in 2092 - a
                            ** fair assumption, n'est-ce pas?]
                            */
    unsigned char   month;  /* 1-12 */
    unsigned char   day;    /* 1-31 */
    unsigned char   hour;   /* 0-23 where 0 is midnight */
    unsigned char   minute; /* 0-59 */
    unsigned char   second; /* 0-59 */
    unsigned char   hsec;   /* hundredths of a second 0-99 */
    char            usage;  /*
							**	Used to fill struct out to 8 chars & provide an
							**	optional indicator of the contents filled in.
							**	All *date_time*() functions will set this
							**	as appropriate.
							** DT_UNUSED, DT_TIME_ONLY, DT_DATE_ONLY, or 
							** DT_DATE_TIME
							*/
} DATE_TIME_T;

/*
**  Use this whenever you want to look at any 4 byte quantity in any
**  other way: i.e. look at individual bytes of a longword, etc.
*/
typedef union   ALLTYPES
{
    unsigned    long    ulong;
    long                slong;
    unsigned    short   ushort[sizeof(long)/sizeof(unsigned short)];
    short               sshort[sizeof(long)/sizeof(short)];
    unsigned    char    uchar[sizeof(long)/sizeof(unsigned char)];
    char                schar[sizeof(long)/sizeof(char)];
} ALLTYPES_T;

#endif	/* GENERI_T_H */
/* end file : generi_t.h */
