
#*****************************************************************************
#* @(#)next_normal_id.mk	1.1 8/31/95 GTE Government Systems Corp.
#*
#* Classification:  TS-HVCCO
#*
#* Project:         CHAMITE
#*
#* Makefile Name:   next_normal_id.mk
#*
#* Description:
#*   Makefile generated by mkmk for next_normal_id in Next_Normal_Id CPC
#*   next_normal_id is a UNIX executable using CenterLine clcc compiler
#*
#* Notes:
#*   Comment lines with no whitespace between the poundsign and text may
#*   be CodeCenter commands.
#*
#* Original Command Line used to create this makefile (Note that dollar signs,
#* quotes, parentheses of all types must be escaped by preceding them with a
#* backslash when reusing this command). [Note: the #*# at the beginning of
#* the line is a special marker for an automated CM script to find & use -
#* please do not remove it.]:
#*
#*# mkmk -t next_normal_id -c Next_Normal_Id -all -DBEEP_MESSAGE\"\(\"_a\"\)\"=\"{}\"
#*
#* Revision History
#*   DATE    S/W ENGINEER     DESCRIPTION OF WORK
#* --------  ---------------  ------------------------------------------------
#* 08/31/95  mkmk             Created from V1.53
#******************************************************************************
#
.SUFFIXES: .o .c .c~ .uid .uil .uil~ .h .h~

# set this to DEBUG=-DDEBUG for Sydd's debug utilities
# set this to DEBUG= for no debug utilities
# THIS HAS NOTHING TO DO WITH SOURCE LEVEL DEBUGGERS LIKE dbg
DEBUG=
#DEBUG=-DDEBUG

# Replace this with location of your local stuff, if needed
LOCALPATH = .

# Locations of common things - See chamite.cshrc for setenv's of these
#COMMONPATH = /devel
#SYBASEPATH = /devel/sybase
#MOTIFPATH = /cots/motif/usr
#X11R5PATH = /cots/X11R5/usr


# Where to find various helpful utilities
LIST_INCLUDES = /usr/local/bin/find_includes
WHAT_HEADERS = /usr/local/bin/what_headers
CALLS = /usr/local/bin/calls
FIX_CS = /usr/local/bin/fix_cs

# Place -I compiler switches here for the various additional places
# you want the compiler to look for include files specified in double quotes
CINCLUDES = \
 -I$(COMMONPATH)/include \
 -I$(SYBASEPATH)/include \
 -I$(MOTIFPATH)/include \
 -I$(X11R5PATH)/include

# Local additions for CFLAG options (i.e. -g for debug info left in object)
# These are compiler specific switches only, not including C preprocessor
# flags.
#  - leave debug info in object file for use with source level debuggers


CFLAGS    += -Xa -g \
 -DBEEP_MESSAGE"("_a")"="{}" \
 


# Local additions for C Preprocessor flags - place -D switches here
CPPFLAGS  += \
 $(DEBUG) \
 $(CINCLUDES)

# Where to find libraries and any loader flags (i.e. -s for strip output)
# NOTE: -s negates in the executable what -g profides in the objects
#       Executable can later be stripped of debug things provided by -g compiler
#       switch using strip(1) command - see also ld(1) manpage
LDFLAGS = \
 -L$(COMMONPATH)/lib \
 -L$(SYBASEPATH)/lib \
 -L$(MOTIFPATH)/lib \
 -L$(X11R5PATH)/lib

# Libraries needed to compile the target (eg: $(LIBDIR)/otherlib.a -llog))
# -lc4_Comms for libc4_Comms.a Library of CHAMITE interprocess communications
# -lc2_Utilities for libc2_Utilities.a Common library of GTE generic utils
# -lm for libm.a standard system math library (for float/double operations)
# -lMrm for OSF/Motif Resource Manager library
# -lXm for OSF/Motif library
# -lXt for X11R5 Xt Intrinsics library
# -lX11 for X11R5 Xlib library
#  NOTE: If you use some of the date related functions from -lc2_Utilities,
#        you may also need to use -lm to get the standard system math lib.
#        You'll know you need to do this if you get an unresolved symbol
#        such as aint (rounding function).
LDLIBS = \
 -lc4_Comms \
 -lc2_Utilities \
 -lMrm \
 -lXm \
 -lXt \
 -lX11 \
 -lm


# Local additions for UIL compiler
UILFLAGS = \
 -wmd $(MOTIFPATH)/bin/X11/motif.wmd \
 -I/usr/include/Mrm \
 -I/usr/include/uil


#
# General Rules (usually provided in Sun's default.mk file in /usr/include/make)
#
CC=clcc

COMPILE.c = \
	$(CC) $(CPPFLAGS) $(CFLAGS) -c
.c.o:
	$(COMPILE.c) -o $@ $<
LINK.c = \
	purelink $(PURIFY) $(PURIFYOPTIONS) $(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS)
.c:
	$(LINK.c) -o $@ $< $(LDLIBS)
#
# Typical archiver (library) command
# Library targets should be built as follows:
#  $(ARPREF)$(TARGET).$(AREXT)
#
AR=/usr/bin/ar
ARFLAGS=r
ARPREF=lib
AREXT=a
.c.a:
	$(COMPILE.c) -o $% $<
	$(AR) $(ARFLAGS) $@ $%
	$(RM) $%

RANLIB=ranlib

# misc file ops commands
RM=/usr/bin/rm
MV=/usr/bin/mv
LN=/usr/bin/ln
LNFLAGS=-s


# UIL support
UIL=uil
COMPILE.uil = \
	$(UIL) $(UILFLAGS)
.uil.uid:
	@$(FIX_CS) $<
	$(COMPILE.uil) -o $@ $<
	-@$(LN) $(LNFLAGS) $@ $(LOCALPATH) >/dev/null 2>&1


############################################################
#                                                          #
# INDIVIDUAL PROGRAMER MODIFICATIONS HERE                  #
#                                                          #
# Note:  Source  and object files are lists of files       #
#        separated by spaces.  Use the backslash (\)  for  #
#        lists that span multiple lines.                   #
#                                                          #
############################################################

# Program to make (binary executable or library minus prefix & suffix)
TARGET  =  next_normal_id$(PURIFY)


# Bindings used by one or more files in TARGET



# Header files for TARGET

INCLUDES.h = \
 $(LOCALPATH)/sdrtags.h \
 $(LOCALPATH)/sdrtool.h \
 $(LOCALPATH)/sdrtool_.h \
 $(LOCALPATH)/sdrtool_g.h \
 $(LOCALPATH)/sdrtool_t.h

# Source files for TARGET

SOURCES.c = \
 $(LOCALPATH)/get_next_id.c \
 $(LOCALPATH)/lockout_idfile.c \
 $(LOCALPATH)/next_normal_id.c \
 $(LOCALPATH)/unlock_idfile.c

SOURCES.uil = \


SOURCES.o = \
	$(SOURCES.c:.c=.o)

OBJECTS = \
	$(SOURCES.o)


SOURCES.uid = \
	$(SOURCES.uil:.uil=.uid)

SOURCES.all = \
	$(SOURCES.c) \
	$(SOURCES.uil)


#
# This is the default object to make (the first colon in the file)
#

$(TARGET): \
 $(INCLUDES.h) \
 $(OBJECTS) g$(TARGET)_include_keys.o $(SOURCES.uid) \
 $(SOURCES.all) g$(TARGET)_include_keys.c
	$(LINK.c) -o $(TARGET) $(OBJECTS) g$(TARGET)_include_keys.o $(LDLIBS)

# Generate a list of functions called by sources in the list
calls:	$(SOURCES.c)
	-@$(RM) -f $(COMMONPATH)/calls/Next_Normal_Id.calls $(COMMONPATH)/calls/Next_Normal_Id.calls.c
	-@cat $(SOURCES.c) > $(COMMONPATH)/calls/Next_Normal_Id.calls.c
	@echo "Call Stack For Next_Normal_Id CPC" > $(COMMONPATH)/calls/Next_Normal_Id.calls
	@$(CALLS) -X -n -t -f main -c "clcc -Xa -E" $(CPPFLAGS) $(COMMONPATH)/calls/Next_Normal_Id.calls.c >> $(COMMONPATH)/calls/Next_Normal_Id.calls
	-@$(RM) -f $(COMMONPATH)/calls/Next_Normal_Id.calls.c
	@echo "Rebuilt callstack for Next_Normal_Id in $(COMMONPATH)/calls/Next_Normal_Id.calls"


# For CodeCenter to load the project
$(TARGET)_project:	$(INCLUDES.h) $(OBJECTS)
	#setopt program_name $(TARGET)
	#setopt load_flags $(CPPFLAGS) $(LDFLAGS)
	#setopt tab_stop 4
	#load $(CPPFLAGS) $(LDFLAGS) $(OBJECTS) $(LDLIBS)
	#link



# Log of what(1) marker lines for all include files used:
# The .c file is dependent upon all include files listed so that
# if one changes, the .c file is regenerated (& thus the .o)
g$(TARGET)_include_keys.c:  $(INCLUDES.h) $(SOURCES.uil)
	-@$(RM) -f g$(TARGET)_include_keys.*
	$(WHAT_HEADERS) -filename g$(TARGET)_include_keys.c \
		$(INCLUDES.h) $(SOURCES.uil) \
		>g$(TARGET)_include_keys.c

# Target to get it to just remake the uid files
uil:	$(SOURCES.uid)



# removes all object files, lintfiles and core if found
clean:
	-$(RM) -f $(OBJECTS) *pure*.o
	-$(RM) -f g*_include_keys.* core a.out

# does clean above PLUS removes the target (executable or library)
clobber:	clean
	-$(RM) -f $(SOURCES.uid)
	-$(RM) -f $(TARGET) $(TARGET).pure*


# Provides make format list of sources and include file dependencies by
# examining includes & sources provided for includes using double quotes.
# Use list_includes for direct includes with double quotes
# Use list_all_includes for direct includes with double quotes AND <> brackets
# Use find_includes for direct AND indirect includes with double quotes
list_includes:
	$(LIST_INCLUDES) $(SOURCES.c) | sed -e 's@^\.@$$(LOCALPATH)@' \
		>$(TARGET).includes


# Install target to $(COMMONPATH)/bin
install: $(COMMONPATH)/bin/$(TARGET)

$(COMMONPATH)/bin/$(TARGET): $(TARGET)
	@echo "Install $(TARGET) in $(COMMONPATH)/bin"
	@install -m 555 $(TARGET) $(COMMONPATH)/bin
	@echo "Install all .uid files in $(COMMONPATH)/bin/UID"
	@/usr/local/bin/multi_install $(COMMONPATH)/bin/UID $(SOURCES.uid)



# Echo list of all files in INCLUDES.h and SOURCES.all to screen
echofiles:
	@echo $(INCLUDES.h) $(SOURCES.all) | tr ' ' '\012'



$(TARGET).depend: depend

$(TARGET).mk.depend: replace_depend

depend:
	-@/bin/rm -f $(TARGET).depend* $(TARGET).depend.tmp* >/dev/null 2>&1
	-@touch $(TARGET).depend.tmp >/dev/null 2>&1
	@makedepend -o.o -w50 -f$(TARGET).depend.tmp -s# SOURCE_DEPENDENCIES_HERE--v -- $(CFLAGS) -I/usr/include $(CINCLUDES) -- $(SOURCES.c) >/dev/null 2>&1
	@mkmk_filter_depend $(TARGET).depend.tmp >$(TARGET).depend
	-@/bin/rm -f $(TARGET).depend.tmp* >/dev/null 2>&1
	@echo "depend: Complete - results in $(TARGET).depend"



replace_depend: $(TARGET).mk $(TARGET).depend
	-@/bin/rm -f $(TARGET).mk.depend* $(TARGET).mk.depend.tmp* >/dev/null 2>&1
	@mkmk_replace_depend $(TARGET).mk $(TARGET).depend > $(TARGET).mk.depend.tmp
	@mkmk_replace_includes $(TARGET).mk.depend.tmp > $(TARGET).mk.depend
	-@/bin/rm -f $(TARGET).mk.depend.tmp* >/dev/null 2>&1
	@echo "replace_depend: Complete - new makefile in $(TARGET).mk.depend"



#
# Place Source Dependencies Here - no longer provided by mkmk
# Use make -f next_normal_id.mk list_includes
#  Then check the resulting $(TARGET).includes file before merging it
#  with this makefile as it makes certain assumptions that may not always
#  be correct (hey, mkmk can't read minds, just source).
# Use show_includes $(TARGET) command to see a unique list of .h files
#  included by all files in the makefile after running the above list_includes
#  option.  The list produced by show_includes should match the list in
#  the INCLUDES.h macro in this makefile BEFORE merging the $(TARGET).includes
#  list below.
#
# SOURCE_DEPENDENCIES_HERE--v


# SOURCE_DEPENDENCIES_HERE--^
#
# End of next_normal_id Makefile
# end file : next_normal_id.mk
