#ifndef	lint
static char sccsid[] = "@(#)printsdr.c	1.4 6/25/94 SyddWare";
#endif
/*****************************************************************************
* Classification:    Unclassified
*
* Project:           SDRTOOL
*
* Module Name:       printsdr.c
*
* Description:
*   
*
* Calling Sequence:
*   
*
*   Inputs:
*       None
*
*   Outputs:
*       None
*
*   Returns:
*       None
*
* Error Conditions and Actions:
*   N/A
*
* Side Effects:
*   N/A
*
* Limitations:
*   N/A
*
* Notes:
*   N/A
*
* Revision History
*   DATE    S/W ENGINEER     DESCRIPTION OF WORK
* --------  ---------------  ------------------------------------------------
*
******************************************************************************/
#include "generi_.h"
#include "sdr_.h"

void	printsdr(sdr,mailfile)
	SDR_T	*sdr;
	FILE	*mailfile;
{
	if (sdr && mailfile)
	{
		fprintf(mailfile,"Project:         %s\n", Table_name);
		fprintf(mailfile,"Orig ID:         %s\n", (*sdr).id[0]);
		if (strcmp((*sdr).id[0], (*sdr).id[1]))
			fprintf(mailfile,"Perm ID:         %s\n", (*sdr).id[1]);
		else
			fprintf(mailfile,"Perm ID:         Not Yet Assigned\n");
		fprintf(mailfile,"Title:           %s\n",(*sdr).title);
		if (!strcmp((*sdr).cpc_mnemonic, "ST"))
			fprintf(mailfile,"Type:            Software\n");
		else if (!strcmp((*sdr).cpc_mnemonic, "HT"))
			fprintf(mailfile,"Type:            Hardware\n");
		else if (!strcmp((*sdr).cpc_mnemonic, "DT"))
			fprintf(mailfile,"Type:            Documentation\n");
		else if (!strcmp((*sdr).cpc_mnemonic, "TT"))
			fprintf(mailfile,"Type:            Requirement\n");
		else if (!strcmp((*sdr).cpc_mnemonic, "VT"))
			fprintf(mailfile,"Type:            COTS\n");
		else if (!strcmp((*sdr).cpc_mnemonic, "UT"))
			fprintf(mailfile,"Type:            Unknown\n");
		else
			fprintf(mailfile,"Type:            Unsupported [%s]\n",
				(*sdr).cpc_mnemonic);
		fprintf(mailfile,"Trouble Area:    %s\n", (*sdr).trouble_area);
		fprintf(mailfile,"Thread:          %s\n", (*sdr).thread);
		fprintf(mailfile,"Originator:      %s\n", (*sdr).originator);
		fprintf(mailfile,"Date Originated: %s\n", (*sdr).originated);
		fprintf(mailfile,"Status:          ");
		switch ((*sdr).status)
		{
			case NEW_CCB1:
				fprintf(mailfile,"New/CCB1\n");
				break;

			case ASSESS:
				fprintf(mailfile,"Assess\n");
				break;

			case ASSIGNED:
				fprintf(mailfile,"Assigned\n");
				break;

			case CCB2:
				fprintf(mailfile,"CCB2\n");
				break;

			case RESOLVED:
				fprintf(mailfile,"Resolved\n");
				break;

			case REJECTED:
				fprintf(mailfile,"Rejected\n");
				break;

			case CMEVAL:
				fprintf(mailfile,"Under CM Evaluation\n");
				break;

			case PROMOTE:
				fprintf(mailfile,"To Be Promoted\n");
				break;

			default:
				fprintf(mailfile,"Unknown [%d]\n",(*sdr).status);
				break;
		}
		fprintf(mailfile,"Last Status Chg: %s\n", (*sdr).transition);
		fprintf(mailfile,"Priority:        %d\n", (int)(*sdr).priority);
		if (!emptyline((*sdr).assigned_to))
		{
			if (!emptyline((*sdr).co_assignee))
				fprintf(mailfile,"Assigned To:     %s - %s\n",
					(*sdr).assigned_to, (*sdr).co_assignee);
			else
				fprintf(mailfile,"Assigned To:     %s\n", (*sdr).assigned_to);
		}
		else
			fprintf(mailfile,"Assigned To:     %s\n", "Not Yet Assigned");
		fprintf(mailfile,"Date Assigned:   %s\n", (*sdr).assigned);
		fprintf(mailfile,"Date Due:        %s\n", (*sdr).due);
		fprintf(mailfile,"Date Closed:     %s\n", (*sdr).closed);
		fprintf(mailfile,"Hours:           %d.%d\n", (*sdr).hours / 100,
			(*sdr).hours % 100);
        APPEND_CONTENTS(mailfile,
            "\n>>>>>>>>>>>>>>>>>>> Comments           <<<<<<<<<<<<<<<<<<<\n",
            sdr->id[0] ,COMMENTS_EXT);
        APPEND_CONTENTS(mailfile,
            "\n>>>>>>>>>>>>>>>>>>> Description        <<<<<<<<<<<<<<<<<<<\n",
            sdr->id[0] ,DESCRIPTION_EXT);
        APPEND_CONTENTS(mailfile,
            "\n>>>>>>>>>>>>>>>>>>> Problem            <<<<<<<<<<<<<<<<<<<\n",
            sdr->id[0] ,PROBLEM_EXT);
        APPEND_CONTENTS(mailfile,
            "\n>>>>>>>>>>>>>>>>>>> Steps to Recreate  <<<<<<<<<<<<<<<<<<<\n",
            sdr->id[0] ,RECREATE_EXT);
        APPEND_CONTENTS(mailfile,
            "\n>>>>>>>>>>>>>>>>>>> Proposed Solution  <<<<<<<<<<<<<<<<<<<\n",
            sdr->id[0] ,SOLUTION_EXT);
        APPEND_CONTENTS(mailfile,
            "\n>>>>>>>>>>>>>>>>>>> Resolution         <<<<<<<<<<<<<<<<<<<\n",
            sdr->id[0] ,RESOLUTION_EXT);
        APPEND_CONTENTS(mailfile,
            "\n>>>>>>>>>>>>>>>>>>> Files Modified     <<<<<<<<<<<<<<<<<<<\n",
            sdr->id[0] ,FILES_EXT);
        APPEND_CONTENTS(mailfile,
            "\n>>>>>>>>>>>>>>>>>>> Build Instructions <<<<<<<<<<<<<<<<<<<\n",
            sdr->id[0] ,BUILD_EXT);
        APPEND_CONTENTS(mailfile,
            "\n>>>>>>>>>>>>>>>>>>> Testing            <<<<<<<<<<<<<<<<<<<\n",
            sdr->id[0] ,TESTING_EXT);
	}
	return;
}
