/*****************************************************************************
* $ID:$ SyddWare Inc.
*
* Binding Name:    sdr_.h
*
* Description:
*   Contains prototypes and macros for SDRTool.
*
* Notes:
*   N/A
*
* Revision History
*   DATE    S/W ENGINEER     DESCRIPTION OF WORK
* --------  ---------------  ------------------------------------------------
* 04/01/93  J.R.(Sydd)Souza  Created
******************************************************************************/
#ifndef	SDR__H
#	define SDR__H

#	include <Mrm/MrmAppl.h>		/* for Widget etc. */
#	include <Xm/Xm.h>			/* for Widget etc. */
#	include <Xm/ArrowB.h>		/* for XmArrowButton things etc. */
#	include <Xm/TextF.h>		/* for XmTextFieldGetString etc. */
#	include <Xm/ToggleB.h>		/* for XmToggleButtonSetState etc. */
#	include <Xm/Scale.h>		/* for XmScaleGetValue etc. */
#	include <time.h>			/* for time() etc. */
#	include "generi.h"	/* for PROTO() macro etc */
#	include "generi_.h"	/* for general prototypes etc. */
#	include "sdr_t.h"      /* for SDR_T etc. */
#	include "sdr_g.h"      /* for Widget_list[] etc. */
#	include "sdrtags.h"		/* for k_* tags */

/*
**	X11R4 & before fix
*/
#	ifndef	XmFONTLIST_DEFAULT_TAG
#		define XmFONTLIST_DEFAULT_TAG XmSTRING_DEFAULT_CHARSET
#	 endif	/* XmFONTLIST_DEFAULT_TAG */

/*
**	Stolen from MMI
*/
void cursor_mgmt
	PROTO((	Widget screen,
			BOOLEAN put_up_stop ));

/*
**	non-ANSI Prototypes
*/
#	ifdef COMMENT_OUT
#		ifdef	__STDC__
int sigblock
    PROTO(( int mask ));
int sigmask
    PROTO(( int signum ));
int sigsetmask
    PROTO(( int mask ));
void    (*signal PROTO(( int sig, void (*func)() )) )();
int access
    PROTO(( char *path,
            int mode ));
#		endif	/* __STDC__ */
#	endif /* COMMENT_OUT */

void    SIGCHLD_handler
	PROTO(( int signal_number ));
void	apply_abort_callback
	PROTO((	Widget w, int *which_one, XmPushButtonCallbackStruct *call ));
void	color_buttons
	PROTO((	char	*sdr_id ));
void	create_callback
	PROTO((	Widget w, int *which_one, XmAnyCallbackStruct *call ));
void destroy_main
	PROTO((	Widget w, int *which_one, XmAnyCallbackStruct *call ));
void docmd_callback
	PROTO((	Widget w, int *which_one, XmPushButtonCallbackStruct *call ));
void edit_file_callback
	PROTO((	Widget w, int *which_one, XmPushButtonCallbackStruct *call ));
BOOLEAN extract_from_window
	PROTO(( SDR_T *sdr, BOOLEAN *isnew, STATUS_T *previous_state,
		char **idfilename  ));
void	fill_it_in
	PROTO(( SDR_T *sdr ));
BOOLEAN get_cpcname
	PROTO((	char *cpc_mnemonic, char *cpcname ));
BOOLEAN get_current_record
	PROTO((	SDR_T *sdr ));
BOOLEAN get_next_id
	PROTO((	ID_PREFIX_T prefix, ID_CODE_T next_id, BOOLEAN saveit ));
int get_username
	PROTO((	char *username ));
BOOLEAN is_a_user
	PROTO((	char *user,
			char *list ));
BOOLEAN isvalidid
	PROTO((	ID_CODE_T id ));
BOOLEAN lockout_idfile
	PROTO(( char **idfilename ));
void mail_me_one
	PROTO((	Widget w, int *which_one, XmPushButtonCallbackStruct *call ));
BOOLEAN notify_user
	PROTO((	char *users, SDR_T *sdr, char *subject ));
void printsdr
	PROTO((	SDR_T *sdr, FILE *mailfile ));
void	set_cpc_option
	PROTO((	Widget optionmenu, char cpc_mnemonic[CPC_CODE_SIZE +1] ));
BOOLEAN unlock_idfile
	PROTO(( char *idfilename ));
BOOLEAN update_database
	PROTO((	BOOLEAN insert_record, SDR_T *sdr ));
void value_changed_callback
	PROTO((	Widget w, int *tag, XmAnyCallbackStruct *call ));

/* Database related functions */
char *sqlprintf
	PROTO(( char *string,
			char *format,
			... ));

int get_discrep_rec
	PROTO((	SDR_T *discrep_record ));

int insert_discrep_rec
	PROTO((	SDR_T *discrep_record ));

int update_discrep_rec
	PROTO((	SDR_T *discrep_record ));

/* Macros */
/*
**	CHECK_AND_DELETE()
**	Checks for existence of filename created from "%s/%s%s" using parms
**	passed to fill these three and deltes file if it exists.
*/
#	define	CHECK_AND_DELETE(_path,_id,_ext)           \
{                                                      \
	char	__filename[MAX_FILENAME_SIZE];             \
	sprintf(__filename,"%s/%s%s",(_path),(_id),(_ext));\
	if (!access(__filename,NOTEXIST))                  \
		remove(__filename);                            \
}

/*
**	RESET_MESSAGE()
**	Updates k_messagelabel label widget with message passed in
*/
#	define	RESET_MESSAGE(_msg)                                     \
{                                                                   \
	XmString	__mymsg;                                            \
	if (Widget_list[k_messagelabel])                                \
	{                                                               \
		__mymsg = XmStringCreateLtoR((_msg),XmFONTLIST_DEFAULT_TAG);\
		if (__mymsg)                                                \
		{                                                           \
			XtVaSetValues(Widget_list[k_messagelabel],              \
				XmNlabelString, __mymsg, NULL);                     \
			XmStringFree(__mymsg);                                  \
		}                                                           \
	}                                                               \
}

/*
**	BEEP_MESSAGE()
**	Updates k_messagelabel label widget with message passed in & beeps
*/
#	define	BEEP_MESSAGE(_bmsg)                          \
{                                                        \
	RESET_MESSAGE(_bmsg);                                \
	if (Widget_list[k_messagelabel])                     \
		XBell(XtDisplay(Widget_list[k_messagelabel]),50);\
}

/*
**	CHECK_AND_REPLACE()
**	Checks for existence of filename created from format strings
**	generated by combining "%s/%s%s" with _real, _src, _ext and
**	replacing it with "%s/%s%s" using _tmp, _dest, _ext.
**	Original source file will be removed if _loseorig is not FALSE
*/
#	define	CHECK_AND_REPLACE(_real,_dest,_tmp,_src,_ext,_loseorig)   \
{                                                                     \
    FILE    *__srcfp;                                                 \
    FILE    *__desfp;                                                 \
	char	__srcfilename[MAX_FILENAME_SIZE];                         \
	char	__desfilename[MAX_FILENAME_SIZE];                         \
	char	__inputline[256];                                         \
	sprintf(__srcfilename,"%s/%s%s",(_tmp),(_src),(_ext));            \
	if (!access(__srcfilename,NOTEXIST) &&                            \
		(__srcfp = fopen(__srcfilename,"r")))                         \
	{                                                                 \
		sprintf(__desfilename,"%s/%s%s",(_real),(_dest),              \
			(_ext));                                                  \
		if (!strcmp(_real,_tmp) && _loseorig) /* just use rename */   \
			rename(__srcfilename,__desfilename);                      \
		else /* must copy the file from one place to another */       \
		{                                                             \
			if ((__desfp = fopen(__desfilename,"w+")))                \
			{                                                         \
				while (fgets(__inputline,sizeof(__inputline),__srcfp))\
					fputs(__inputline,__desfp);                       \
				fclose(__desfp);                                      \
			}                                                         \
			fclose(__srcfp);                                          \
			if (_loseorig)                                            \
		    	remove(__srcfilename);                                \
		}                                                             \
	}                                                                 \
}

/*
**	CURRENT_DATE()
**		char _curdat[DATE_STRING_SIZE +1]; in form "MMM dd yyyy hh:mmAM"
*/
#	define	CURRENT_DATE(_curdat)                                        \
{                                                                        \
	struct tm *__timeptr;                                                \
	time_t    __timenow;                                                 \
	time(&__timenow);                                                    \
	__timeptr = localtime(&__timenow);                                   \
	strftime(_curdat, sizeof(_curdat), SdrTool.dateformat,__timeptr);    \
}                                                                        \

/*
**	RESET_ALLFIELDS()
**	Takes no parms: resets all pertinent fields on display to initial
**	or blank value as appropriate.
*/
#	define	RESET_ALLFIELDS()                                                \
{     																		 \
	extern	Widget	Shell000;                                                \
    XmString	__origstring;                                                \
	char __today[DATE_STRING_SIZE +1];                                       \
	char __tempstring[256];                                                  \
	if ( Widget_list[ k_idtextField ] )                                      \
		XmTextFieldSetString( Widget_list[ k_idtextField ], "" );            \
    sprintf(__tempstring,"Orig #:               ");                          \
    __origstring = XmStringCreateLtoR(__tempstring, XmFONTLIST_DEFAULT_TAG); \
	if ( Widget_list[k_masteriddrawnButton] )                                \
    	XtVaSetValues(Widget_list[k_masteriddrawnButton],                    \
        	XmNlabelString, __origstring, NULL);                             \
    XmStringFree(__origstring);                                              \
    sprintf(__tempstring,"Perm #:               ");                          \
    __origstring = XmStringCreateLtoR(__tempstring, XmFONTLIST_DEFAULT_TAG); \
	if ( Widget_list[k_catiddrawnButton] )                                   \
    	XtVaSetValues(Widget_list[k_catiddrawnButton],                       \
        	XmNlabelString, __origstring, NULL);                             \
    XmStringFree(__origstring);                                              \
	if ( Widget_list[ k_priorityscale ] )                                    \
		XmScaleSetValue( Widget_list[ k_priorityscale ], 3 );                \
	if ( Widget_list[ k_titletextField ] )                                   \
		XmTextFieldSetString( Widget_list[ k_titletextField ], "" );         \
	if ( Widget_list[ k_newtoggleButton ] )                                  \
		XmToggleButtonSetState( Widget_list[ k_newtoggleButton ],            \
			True, True );                                                    \
	if ( Widget_list[ k_originatortextField ] )                              \
		XmTextFieldSetString( Widget_list[ k_originatortextField ], "" );    \
	if ( Widget_list[ k_co_assigneetextField ] )                             \
		XmTextFieldSetString( Widget_list[ k_co_assigneetextField ], "" );   \
	if ( Widget_list[ k_assignedtextField ] )                                \
		XmTextFieldSetString( Widget_list[ k_assignedtextField ], "" );      \
	if ( Widget_list[ k_threadtextField ] )                                  \
		XmTextFieldSetString( Widget_list[ k_threadtextField ], "" );        \
	if ( Widget_list[ k_transdatetextField ] )                               \
		XmTextFieldSetString( Widget_list[ k_transdatetextField ], "" );     \
	if ( Widget_list[ k_hourstextField ] )                                   \
		XmTextFieldSetString( Widget_list[ k_hourstextField ], "0.00" );     \
	if (Widget_list[ k_hourstextField ] )                                    \
		XtVaSetValues(Widget_list[ k_hourstextField ], XmNuserData,          \
	    	1, NULL);                                                        \
	CURRENT_DATE(__today);                                                   \
	if ( Widget_list[ k_originatedatetextField ] )                           \
		XmTextFieldSetString( Widget_list[ k_originatedatetextField ],       \
			__today);                                                        \
	if ( Widget_list[ k_assigndatetextField ] )                              \
		XmTextFieldSetString( Widget_list[ k_assigndatetextField ], "");     \
	if ( Widget_list[ k_tooltextField ] )             		                 \
		XmTextFieldSetString( Widget_list[ k_tooltextField ], "");           \
    if (Widget_list[ k_duedatedrawnButton ])                                 \
    {                                                                        \
        strcpy(__tempstring,"                                       ");      \
        __origstring = XmStringCreateLtoR(__tempstring,                      \
            XmFONTLIST_DEFAULT_TAG);                                         \
        XtVaSetValues(Widget_list[k_duedatedrawnButton],                     \
            XmNlabelString, __origstring,                                    \
            NULL);                                                           \
        XmStringFree(__origstring);                                          \
    }                                                                        \
	if ( Widget_list[ k_closedatetextField ] )                               \
		XmTextFieldSetString( Widget_list[ k_closedatetextField ], "");      \
	if ( Widget_list[k_unselectedButton] )                                   \
		XmToggleButtonSetState(Widget_list[k_unselectedButton], True, True); \
	if ( Widget_list[ k_softtoggleButton ] )                                 \
	{                                                                        \
		XtVaSetValues(Widget_list[ k_softtoggleButton ], XmNuserData,        \
			1, NULL) ;                                                       \
		XmToggleButtonSetState(Widget_list[k_softtoggleButton], True, True); \
	}                                                                        \
	if ( Widget_list[k_softwareunknownButton] )                              \
		XmToggleButtonSetState(Widget_list[k_softwareunknownButton],         \
			True, True);                                                     \
	if ( Widget_list[k_styperadioBox] )                       	             \
		XtVaSetValues(Widget_list[k_styperadioBox], XmNuserData, 0, NULL);   \
	if (Widget_list[k_hardwareunknownButton] )                               \
		XmToggleButtonSetState(Widget_list[k_hardwareunknownButton],         \
			True, True);                                                     \
	if (Widget_list[k_htyperadioBox] )                       		         \
		XtVaSetValues(Widget_list[k_htyperadioBox], XmNuserData, 0, NULL) ;  \
	if (Widget_list[k_documentunknownButton] )                               \
		XmToggleButtonSetState(Widget_list[k_documentunknownButton],         \
			True, True);                                                     \
	if (Widget_list[k_dtyperadioBox] )                       		         \
		XtVaSetValues(Widget_list[k_dtyperadioBox], XmNuserData, 0, NULL) ;  \
	if (Widget_list[k_vendorunknownButton] )                                 \
		XmToggleButtonSetState(Widget_list[k_vendorunknownButton],           \
			True, True) ;                                                    \
	if (Widget_list[k_vtyperadioBox] )                       		         \
		XtVaSetValues(Widget_list[k_vtyperadioBox], XmNuserData, 0, NULL) ;  \
	sprintf(__tempstring,"[%s] {%s} SDRTool", Table_name, username);         \
	XtVaSetValues(Shell000, XmNiconName, __tempstring, NULL);                \
	color_buttons((char *)"NEW");                                            \
}

/*
**	FILL_IT_IN()
**	Takes filled in SDR_T: resets all pertinent fields on display to
**	values from structure as appropriate.
*/
#	define	FILL_IT_IN(_sdr)	fill_it_in(&_sdr)


/*
**	APPEND_CONTENTS()
**	Appends contents of <path>/_ext/_id_ext to _file (if it exists)
**	to _file after also printing _title.  If the file doesn't exist,
**	nothing is done unless _ext matches DESCRIPTION_EXT, in which
**	case _title and "No Description Given\n" is appended to _file.
*/
#	define	APPEND_CONTENTS(_file,_title,_id,_ext)                   \
{                                                                    \
	FILE	*__fp;                                                   \
	char	__filename[MAX_FILENAME_SIZE +1];                        \
	char	__buffer[256];                                           \
	sprintf(__filename,"%s/%s/%s%s",SdrTool.sdrpath,(_ext),(_id),    \
		(_ext));                                                     \
	if (!access(__filename,NOTEXIST) &&                              \
		(__fp = fopen((__filename),"r")))                            \
	{                                                                \
		fprintf((_file),(_title));                                   \
		while (fgets(__buffer,sizeof(__buffer),__fp))                \
		{                                                            \
			fprintf((_file),"> ");                                   \
			fputs(__buffer,(_file));                                 \
	    }                                                            \
		fclose(__fp);                                                \
	}                                                                \
	else                                                             \
	{                                                                \
		if (!strcmp((_ext),DESCRIPTION_EXT))                         \
			fprintf((_file),"%s> No Description Given\n", (_title)); \
	}                                                                \
}

/*
**  Signal Handling macros
*/
/*
**  BLOCK_SIGNAL()
**  Takes an int mask to be saved until UNBLOCK_SIGNAL() is called.
**  Also takes the signal to be blocked (constant prefixed by SIG like
**  SIGCHLD from signal.h).
**  Blocks _signal events, preventing them until unblocked.
*/
#	define BLOCK_SIGNAL(_signal,_sigmask)  _sigmask=sigblock(sigmask(_signal))

/*
**  UNBLOCK_SIGNAL()
**  Takes an int mask set by BLOCK_SIGNAL() (parm of same name) to restore
**  the last blocked signal by resetting mask back to value in _sigmask.
*/
#	define UNBLOCK_SIGNAL(_sigmask)    _sigmask=sigsetmask(_sigmask)

/*
**  INSTALL_SIGNAL_HANDLER()
**  Takes a signal to be received (int constant prefixed by SIG like SIGCHLD
**  from signal.h) and the name of a routine declared (at a minimum) as
**  void _handler().
**  Installs _handler to receive _signal events.  Reports to stderr if this
**  fails.
*/
#	ifdef	__STDC__
#		define INSTALL_SIGNAL_HANDLER(_signal,_handler)               \
if ((int)signal(_signal, _handler) == -1)                             \
    fprintf(stderr,                                                   \
    "INSTALL_SIGNAL_HANDLER: FAILED TO INSTALL %s EVENT HANDLER %s\n",\
        #_signal,#_handler)
#	else	/* __STDC__ */
#		define INSTALL_SIGNAL_HANDLER(_signal,_handler)               \
if ((int)signal(_signal, _handler) == -1)                             \
    fprintf(stderr,                                                   \
    "INSTALL_SIGNAL_HANDLER: FAILED TO INSTALL %s EVENT HANDLER %s\n",\
        "_signal","_handler")
#	endif	/* __STDC__ */
/*
**  REMOVE_SIGNAL_HANDLER()
**  Takes a signal to be ignored (int constant prefixed by SIG like SIGCHLD
**  from signal.h).
**  Turns off handler for _signal event.
*/
#	define REMOVE_SIGNAL_HANDLER(_signal)  signal(_signal,SIG_IGN)

/*
**  MEMBER_OFFSET()
**  returns byte offset within p_type of member
**  Stolen from X11R5 Instrinsic.h's XtOffset() non-CRAY version.
**  See Xt Intrinsics Library Reference manual entry for XtOffset() for
**  more info.  Parms are a struct type and member name.
**  Example:
**  struct  bob
**  {
**      long  sam;
**      short dan;
**      long  joe;
**  };
**
**  Assuming the compiler has had to add 2 pad bytes between dan and joe
**  to get joe on an even 4-byte boundary (which it probably has):
**  MEMBER_OFFSET(struct bob,sam) yields 0
**  MEMBER_OFFSET(struct bob,dan) yields 4
**  MEMBER_OFFSET(struct bob,joe) yields 8
**  sizeof(struct bob) = 12
**
**  If you rearrange things so dan is after joe, you'd get the following:
**  MEMBER_OFFSET(struct bob,sam) yields 0
**  MEMBER_OFFSET(struct bob,dan) yields 8
**  MEMBER_OFFSET(struct bob,joe) yields 4
**  sizeof(struct bob) = 10
**
**  In any case, this macro would give you the correct offsets no matter what
**  the compiler does.
*/
#ifndef	MEMBER_OFFSET
#	define MEMBER_OFFSET(_p_type,_field) \
    ((unsigned int) (((char *) (&(((_p_type)NULL)->_field))) - ((char *) NULL)))
#endif	/* MEMBER_OFFSET() */

#endif	/* SDR__H */
/* end file: sdr_.h */
