/*****************************************************************************
* $Id: sdr_g.h,v 1.9 1995/09/11 01:52:30 sydd Exp $ SyddWare
*
* Classification:  Unclassified
*
* Project:         SDRTOOL
*
* Binding Name:    sdr_g.h
*
* Description:
*   Globals related to SDRTool.
*
* Notes:
*   N/A
*
* Revision History
*   DATE    S/W ENGINEER     DESCRIPTION OF WORK
* --------  ---------------  ------------------------------------------------
* 04/01/93  J.R.(Sydd)Souza  Created
******************************************************************************/
#ifndef	SDR_G_H
#	define SDR_G_H

/*
** This should match the number of project sets defined in
** supported_tables.h
*/
#	define	NUM_SUPPORTED_TABLES	(5)

#	if defined(__CLCC__) && defined(__STDC__)
#  	 pragma Warning_level(0)
#	endif
#	include <X11/Xlib.h>
#	include <Mrm/MrmAppl.h>
#	if defined(__CLCC__) && defined(__STDC__)
#   	pragma Warning_level(4)
#	endif

#	include "generi.h"		/* for EXTERN */
#	include "sdr_t.h"		/* for PROCESS_TABLE_T */
#	include "sdr_.h"		/* for callback prototypes */
#	include "sdrtags.h"		/* for MAX_TAGS */

/*
**	Working directory (usually /tmp/[getpid()]
*/
EXTERN	char	Tempdir[L_tmpnam];

/*
**	Working database (table name is Table_name_sdrs)
**  String will be converted to all lowercase & prepended to _sdrs
**  for use in queries/inserts/updates.  String is dynamically allocated
**	from argv[1]'s size.
*/
EXTERN	char	*Table_name
#ifdef	MAIN_PROGRAM
 = (char *)0
#endif	/* MAIN_PROGRAM */
;

/*
**	User running the program
*/
EXTERN	char	username[L_tmpnam];

/*
**	Global to store resources
*/
EXTERN	AppData	SdrTool;

/*
**	Toggle button Status widgets
*/
EXTERN  Widget  Previous_status
#	ifdef	MAIN_PROGRAM
 = (Widget)0
#	endif	/* MAIN_PROGRAM */
;
EXTERN  Widget  Current_status
#	ifdef	MAIN_PROGRAM
 = (Widget)0
#	endif	/* MAIN_PROGRAM */
;

/*
**	Global to store widget ids of widgets that may change values;
**	filled by calls to create_callback().
*/
EXTERN	Widget	Widget_list[MAX_TAGS];

/* used to keep track of which files we're currently editing: -1=not editing */
EXTERN	PROCESS_TABLE_T	Process_table[]
#	ifdef	MAIN_PROGRAM
= {
	{ BUILD_EXT,		-1, ""  },	/* note: 3rd mem holds id in use */
	{ DESCRIPTION_EXT,	-1, ""  },
	{ FILES_EXT,		-1, ""  },
	{ COMMENTS_EXT,		-1, ""  },
	{ PROBLEM_EXT,		-1, ""  },
	{ RECREATE_EXT,		-1, ""  },
	{ RESOLUTION_EXT,	-1, ""  },
	{ SOLUTION_EXT,		-1, ""  },
	{ TESTING_EXT,		-1, ""  },
	{ VALIDATED_EXT,	-1,	""  },
	{ PERFORMED_EXT,	-1,	""  },
	{ HELP_FILE_EXT,	-1, ""  },
	{ (char *)0,		-1, ""  }
  }
#	endif	/* MAIN_PROGRAM */
; /* 1 for each ext, null terminated list */

/*
**	SdrTool.sdrpath
** This is the base directory beneath which we find the following:
**	.	- .mail_me_one script for mailing a copy to a user
**		- DEFIDFILE file holding current "next ids"
**		- .replace_files script for replacing N##### files in RCS
**		- RCS main dir for N#####.* file storage
**		- .build_instructions directory for N##### files & link to ../RCS
**		- .description directory for N##### files & link to ../RCS
**		- .files_modified directory for N##### files & link to ../RCS
**		- .comments directory for N##### files & link to ../RCS
**		- .problem directory for N##### files & link to ../RCS
**		- .steps_to_recreate directory for N##### files & link to ../RCS
**		- .resolution directory for N##### files & link to ../RCS
**		- .proposed_solution directory for N##### files & link to ../RCS
**		- .testing directory for N##### files & link to ../RCS
**		- .validated directory for N##### files & link to ../RCS
**		- .performed directory for N##### files & link to ../RCS
**		- .help directory for online.help file (Help button)
*/

/*
**	SdrTool.sdridfile
**	This is the name of the file containing the NEXT id to be used in each
**	category, 1 per line.  Later the syntax may be more forgiving, but for
**	now, 1 per line, firstword, no particular order (see sample file).
**	Numbers in here are "one upped" by get_next_id().
*/

/*
**	SdrTool.sdrsqlcmd
**	This is the text of the command to be used for all database updates.
**	NOTE: This command should cause the results of any given command to
**	appear totally on a line.  In other words, (and especially) the single
**	record query will probably take upwards of 500 bytes to display.  If
**	your command automatically splits lines at 80 (or some other auto)
**	column limit [as does Sybase's isql command - at 80]) but has a way of
**	specifying a longer line limit (-w switch for isql), you should use
**	it with around 500 as the limit.  See the default in the sdr.h file.
**	All commands will take the following form:
**		In a separate file:
**			<command - insert, update or query>
**			go
**			exit
**		Executed via system() call:
**		Sqlcmd < commandfile > logfile
*/

/*
**	SdrTool.ccbmembers
**	This should be one string.
**	If you want to make it multiple users, place all names in a single
**	string separated by commas (e.g. "bob,sam").  This should include all
**	CCB member's accountnames NOT INCLUDING CCB_ACCOUNTNAME which is sent
**	a copy separately (when applicable).
*/

/*
** These are populated in sdrtables.c generated by the mkchoices script
*/
EXTERN	CPC_NAME_T		*CPC_table;
EXTERN	VENDOR_NAME_T	*vendor_table;
EXTERN	DOCUMENT_NAME_T	*document_table;
EXTERN	HARDWARE_NAME_T	*hardware_table;

/*
 * Widget variable declarations.
 */
EXTERN Widget AppShell; /* The Main Application Shell */
EXTERN Widget Shell000;
EXTERN Widget SDRform;

/* Note: will probably get overwritten by XtGetApplicationResources */
EXTERN XtResource   resources[]
#ifdef	MAIN_PROGRAM
= {
    {   "sdrPath", "SdrPath", XtRString, sizeof(SdrTool.sdrpath),
        XtOffset(AppDataPtr, sdrpath), XtRString, SDRPATH },
    {   "sdrIdFile", "SdrIdFile", XtRString, sizeof(SdrTool.sdridfile),
        XtOffset(AppDataPtr, sdridfile), XtRString, ".assign" },
    {   "sdrSqlCmd", "SdrSqlCmd", XtRString, sizeof(SdrTool.sdrsqlcmd),
        XtOffset(AppDataPtr, sdrsqlcmd), XtRString, SDRSQLCMD },
    {   "sdrCmAcct", "SdrCmAcct", XtRString, sizeof(SdrTool.cmaccountname),
        XtOffset(AppDataPtr, cmaccountname), XtRString, CM_ACCOUNTNAME },
    {   "sdrCcb", "SdrCcb", XtRString, sizeof(SdrTool.ccbmembers),
        XtOffset(AppDataPtr, ccbmembers), XtRString, CCB_MEMBERS },
    {   "sdrDateFormat", "SdrDateFormat", XtRString, sizeof(SdrTool.dateformat),
        XtOffset(AppDataPtr, dateformat), XtRString, SDRDATEFORMAT },
    {   "name", "Name", XtRString, sizeof(SdrTool.name),
        XtOffset(AppDataPtr, name), XtRString, "Not Specified" },
    {   "validateFn", "ValidateFn", XtRString, sizeof(SdrTool.validatefn),
        XtOffset(AppDataPtr, validatefn), XtRString, "ls" },
    {   "performFn", "PerformFn", XtRString, sizeof(SdrTool.performfn),
        XtOffset(AppDataPtr, performfn), XtRString, "ls" }
  }
#endif	/* MAIN_PROGRAM */
;

EXTERN char *UidFile []
#ifdef	MAIN_PROGRAM
/* 2nd one is for ?_sdrtables.uil file */
= { UID_FILE_NAME, (char *)0 }
#endif	/* MAIN_PROGRAM */
;

EXTERN Arg args[]
#ifdef	MAIN_PROGRAM
= {
    { XmNtitle, (XtArgVal) "SDRTool" }, /* always leave this first */
    { XmNiconName, (XtArgVal) "SDRTool" },
    { XmNallowShellResize, (XtArgVal) False },
    { XmNwinGravity, (XtArgVal) NorthWestGravity },
    { XmNdeleteResponse, (XtArgVal) XmDESTROY },
	{ (String) 0, (XtArgVal) 0 }
}
#endif	/* MAIN_PROGRAM */
;

/*--------------------- Database support ---------------------*/

extern	CPC_NAME_T
  abc_CPC_table[]
, sdrtool_CPC_table[]
;

extern	VENDOR_NAME_T
  abc_vendor_table[]
, sdrtool_vendor_table[]
;

extern	DOCUMENT_NAME_T
  abc_document_table[]
, sdrtool_document_table[]
;

extern  HARDWARE_NAME_T
  abc_hardware_table[]
, sdrtool_hardware_table[]
;

#endif	/* SDR_G_H */
/* end file : sdr_g.h */
