#ifndef	lint
static char sccsid[] = "$Id: sdrtool.c,v 1.9 1995/09/11 01:52:23 sydd Exp $ SyddWare";
#endif
/*****************************************************************************
* Classification:    Unclassified
*
* Project:           SDRTOOL
*
* Module Name:       sdrtool.c
*
* Description:
*   
*
* Calling Sequence:
*   
*
*   Inputs:
*       None
*
*   Outputs:
*       None
*
*   Returns:
*       None
*
* Error Conditions and Actions:
*   N/A
*
* Side Effects:
*   N/A
*
* Limitations:
*   N/A
*
* Notes:
*   N/A
*
* Revision History
*   DATE    S/W ENGINEER     DESCRIPTION OF WORK
* --------  ---------------  ------------------------------------------------
*
******************************************************************************/

/*
 * System Include Files
 */
#include <stdlib.h>
#include <signal.h>
#include <sys/stat.h>	/* for S_IRWXU etc */

/*
 * Required Motif Include Files
 */
#include <X11/Xlib.h>
#if defined(__CLCC__) && defined(__STDC__)
#   pragma Warning_level(0)
#endif
#include <Mrm/MrmAppl.h>
#if defined(__CLCC__) && defined(__STDC__)
#   pragma Warning_level(4)
#endif

#define	MAIN_PROGRAM
#include "sdr_.h"	/* everything else is from here */
#include "sdr_g.h"	/* globals */

static MRMRegisterArg NamesList[] =
{
    { "apply_abort_callback",   (XtPointer)apply_abort_callback },
    { "create_callback",        (XtPointer)create_callback },
    { "docmd_callback",         (XtPointer)docmd_callback },
    { "edit_file_callback",     (XtPointer)edit_file_callback },
    { "mail_me_one",            (XtPointer)mail_me_one },
    { "value_changed_callback", (XtPointer)value_changed_callback },
    { "destroy_main",           (XtPointer)destroy_main },
};

/* See number of entries in supported_tables.h file */
SUPPORT_T   Supported_tables[NUM_SUPPORTED_TABLES+1];

/*
 * Main Program.
 */
main(argc, argv)
	int argc;
	char **argv;
{
	Display *display;
	XtAppContext context;
	Cardinal	argcnt;
	char	*title = (char *)0;
	int	icnt;
	Widget	stypepopup;
	Widget	vtypepopup;
	Widget	dtypepopup;
	Widget	htypepopup;

	char	tempstring[1024];

	/*
	** Hierarchy variables
	*/
	MrmHierarchy HierarchyID;
	MrmType MrmWClass;

	/* Initialize table */
	icnt=-1;
#	include "supported_tables.h"

	sprintf(Tempdir,"/tmp/%d", getpid());
	if (!access(Tempdir,NOTEXIST))
	{
		rmdir(Tempdir);
	}
	mkdir(Tempdir,S_IRWXU|S_IRWXG);

	memset(&SdrTool, 0, sizeof(SdrTool));
	/*
	**	Install child reaper
	*/
	INSTALL_SIGNAL_HANDLER(SIGCHLD, SIGCHLD_handler);

    MrmInitialize();
    XtToolkitInitialize();
    context = XtCreateApplicationContext();
	/* Don't give it a name, that's how they tell us which db */
    display = XtOpenDisplay(context, 0, NULL, APP_CLASS, 
        0, 0, (Cardinal*)&argc, argv);
    if(display == NULL)
    {
		char termessage[256];

		sprintf(termessage,"%s: Cannot open display - terminating",argv[0]);
		XtWarning(termessage);
		exit(ENXIO);
    }

    /*
     * So converters work.
     */
    XtInitializeWidgetClass(applicationShellWidgetClass);

    /*
     * The applicationShell is created as an unrealized
     * parent for multiple topLevelShells.  The topLevelShells
     * are created as popup children of the applicationShell.
     * This is a recommendation of Paul Asente & Ralph Swick in
     * _X_Window_System_Toolkit_ p. 677.
     */
    AppShell = XtAppCreateShell( NULL, APP_CLASS,
            applicationShellWidgetClass, display, args, 0);

    /*
    **  Get resources specific to this one.
    */

    XtGetApplicationResources(AppShell, &SdrTool,
        resources, XtNumber(resources), NULL, 0);

#ifdef	DEBUG
    printf("name=[%s]\n",SdrTool.name);
    printf("sdrpath=[%s]\n",SdrTool.sdrpath);
    printf("sdridfile=[%s]\n",SdrTool.sdridfile);
    printf("sdrsqlcmd=[%s]\n",SdrTool.sdrsqlcmd);
    printf("cmaccountname=[%s]\n",SdrTool.cmaccountname);
    printf("ccbmembers=[%s]\n",SdrTool.ccbmembers);
    printf("dateformat=[%s]\n",SdrTool.dateformat);
    printf("validatefn=[%s]\n",SdrTool.validatefn);
    printf("performfn=[%s]\n",SdrTool.performfn);
#endif	/* DEBUG */

	if (access(SdrTool.sdrpath,NOTEXIST))
    {
        char termessage[256];

        sprintf(termessage,"%s: Error - path [%s] for project %s not found",
            argv[0], SdrTool.sdrpath, SdrTool.name);
        XtWarning(termessage);
        exit(ENOENT);
    }

    if (!strcmp(SdrTool.name,"Not Specified"))
    {
        char termessage[256];

        sprintf(termessage,"%s: Error - You must specify a database table name\
\n   via -name dbname",
            argv[0]);
        XtWarning(termessage);
        exit(ENOENT);
    }
    else
    {
        s_tolower(SdrTool.name);
        for (icnt=0;SdrTool.name[icnt] && isalnum(SdrTool.name[icnt]);++icnt);
        if (SdrTool.name[icnt])
        {
            char termessage[256];

            sprintf(termessage,"%s: Error - You must specify a database table \
name\n   using alphanumeric characters ONLY (letters & numbers case \
independent.\n",
                argv[0]);
            XtWarning(termessage);
            exit(EINVAL);
        }

        for (icnt=0; Supported_tables[icnt].dbname &&
            strcmp(SdrTool.name,Supported_tables[icnt].dbname);++icnt);
        if (!Supported_tables[icnt].dbname)
        {
            char termessage[256];

            sprintf(termessage,"%s: Unsupported database %s: Contact your\n\
local Syddware vendors to add support or try one of these:\n",
                argv[0], SdrTool.name);
            XtWarning(termessage);
            termessage[0] = '\0';
            for (icnt=0; Supported_tables[icnt].dbname;++icnt)
            {
                strcat(termessage," ");
                strcat(termessage,Supported_tables[icnt].dbname);
            }
            XtWarning(termessage);
            exit(EINVAL);
        }
        else
        {
            Table_name = Supported_tables[icnt].dbname;
            UidFile[1] = Supported_tables[icnt].uidfilename;
            CPC_table = Supported_tables[icnt].CPC_table;
            vendor_table = Supported_tables[icnt].vendor_table;
            document_table = Supported_tables[icnt].document_table;
            hardware_table = Supported_tables[icnt].hardware_table;
        }
    }


    HierarchyID = 0;
    argcnt = MrmOpenHierarchyPerDisplay(display, (MrmCount)(2),UidFile,0,
		&HierarchyID);
	if (MrmSUCCESS != argcnt)
	{
		char termessage[256];

		sprintf(termessage, "\
Please make sure its path appears in the UIDPATH environment variable -\n\
or in a standard X location.\n");
		XtWarning(termessage);
		exit(EBADF);
	}
    MrmRegisterNames(NamesList, XtNumber(NamesList));

    XtInitializeWidgetClass(topLevelShellWidgetClass);

    /*
     *  Setup the title with "SDRTool: [dbname] {username]"
     */
    get_username(username);
    title = (char *)CALLOC(1,strlen("SDRTool: [%s] {%s}")+strlen(Table_name)+
        strlen(username)+1);
    sprintf(title,"SDRTool: [%s] {%s}", Table_name, username);
	args[0].value = args[1].value = (XtArgVal)title;
    Shell000 = XtCreatePopupShell( "SDRTool", 
        topLevelShellWidgetClass, AppShell, args, XtNumber(args));
    FREE(title);

    XtAddCallback((Widget)Shell000, XmNdestroyCallback,
		(XtCallbackProc)destroy_main, (XtPointer)0);

    SDRform =  NULL;
    MrmFetchWidget(HierarchyID, "sDRform", Shell000,
        &SDRform, &MrmWClass);

    stypepopup =  NULL;
    MrmFetchWidget(HierarchyID, "stypepopup", SDRform,
        &stypepopup, &MrmWClass);

    vtypepopup =  NULL;
    MrmFetchWidget(HierarchyID, "vtypepopup", SDRform,
        &vtypepopup, &MrmWClass);

    dtypepopup =  NULL;
    MrmFetchWidget(HierarchyID, "dtypepopup", SDRform,
        &dtypepopup, &MrmWClass);

    htypepopup =  NULL;
    MrmFetchWidget(HierarchyID, "htypepopup", SDRform,
        &htypepopup, &MrmWClass);

    MrmCloseHierarchy(HierarchyID);
    XtManageChild(SDRform);
    XtPopup(XtParent(SDRform), XtGrabNone);

	/* if cm user, make Permanent Button look like a push button */
	if (!strcmp(username, SdrTool.cmaccountname))
	{
		XtVaSetValues(Widget_list[k_catiddrawnButton],
			XmNshadowType, XmSHADOW_OUT,
			XmNpushButtonEnabled, True,
			NULL);
	}

    XtAppMainLoop(context);
	exit(0);
} /* end main */
/* end sdrtool.c */
