#*****************************************************************************
#* $Id: sdrtool.mk,v 1.6 1995/04/30 22:22:00 sydd Exp sydd $ SyddWare Inc.
#*
#* Makefile Name:   sdrtool.mk
#*
#* Description:
#*   Makefile generated by mkmk for sdrtool in SDRTool CPC
#*   sdrtool is a UNIX executable using cc compiler
#*
#* Notes:
#*   Comment lines with no whitespace between the poundsign and text may
#*   be CodeCenter commands.
#*
#* Original Command Line used to create this makefile (Note that dollar signs,
#* quotes, parentheses of all types must be escaped by preceding them with a
#* backslash when reusing this command). [Note: the #*# at the beginning of
#* the line is a special marker for an automated CM script to find & use -
#* please do not remove it.]:
#*
#*# mkmk.latest -t sdrtool -c SDRTool -L.
#*    # mkmk.latest -t sdrtool -c SDRTool -D_NO_PROTO -DMOTIF_1_1
#*
#* Revision History
#*   DATE    S/W ENGINEER     DESCRIPTION OF WORK
#* --------  ---------------  ------------------------------------------------
#* 03/22/94  mkmk             Created from V1.5
#******************************************************************************
#
.SUFFIXES: .o .c .c~ .uid .uil .uil~ .h .h~

# set this to DEBUG=-DDEBUG for Sydd's debug utilities
# set this to DEBUG= for no debug utilities
# THIS HAS NOTHING TO DO WITH SOURCE LEVEL DEBUGGERS LIKE dbg
DEBUG=
#DEBUG=-DDEBUG

# Replace this with location of your local stuff, if needed
LOCALPATH = .

# Locations of common things - See .cshrc for setenv's of these
COMMONPATH = .
#DATABASEPATH = /devel/sybase
#MOTIFPATH = /usr/lib
#MOTIFIPATH = /usr/include
X11PATH = /cots/X11R5/usr/lib
X11IPATH = /cots/X11R5/usr/include


# Where to find various helpful utilities
LIST_INCLUDES = find_includes
WHAT_HEADERS = what_headers
CALLS = calls

# Place -I compiler switches here for the various additional places
# you want the compiler to look for include files specified in double quotes
CINCLUDES = \
 -I$(X11IPATH) \
 -I$(COMMONPATH)/include

# Local additions for CFLAG options (i.e. -g for debug info left in object)
# These are compiler specific switches only, not including C preprocessor
# flags.
#  - leave debug info in object file for use with source level debuggers
CFLAGS    =  -Xa -g

# Local additions for C Preprocessor flags - place -D switches here
CPPFLAGS  = $(DEBUG) $(CINCLUDES)

# Where to find libraries and any loader flags (i.e. -s for strip output)
# NOTE: -s negates in the executable what -g profides in the objects
#       Executable can later be stripped of debug things provided by -g compiler
#       switch using strip(1) command - see also ld(1) manpage
LDFLAGS = \
 -L$(X11PATH) \
 -L. \
 -L$(COMMONPATH)/lib

# Libraries needed to compile the target (eg: $(LIBDIR)/otherlib.a -llog))
# -lutilities for libutilities.a Common library of generic utils
# -lm for libm.a standard system math library (for float/double operations)
# -lMrm for OSF/Motif Resource Manager library
# -lXm for OSF/Motif library
# -lXt for X11R5 Xt Intrinsics library
# -lX11 for X11R5 Xlib library
#  NOTE: If you use some of the date related functions from -lutilities,
#        you may also need to use -lm to get the standard system math lib.
#        You'll know you need to do this if you get an unresolved symbol
# /usr/src/libc-linux/malloc-930716/gmalloc.o
#        such as aint (rounding function).
LDLIBS = \
 -lutilities \
 -lMrm -lXm -lXt -lX11 -lm


# Local additions for UIL compiler
UILFLAGS = \
 -I/include/Mrm \
 -I/include/uil


#
# General Rules (usually provided in Sun's default.mk file in /include/make)
#
CC=clcc

COMPILE.c = \
	$(CC) $(CPPFLAGS) $(CFLAGS) -c
.c.o:
	$(COMPILE.c) -o $@ $<
LINK.c = \
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS)
.c:
	$(LINK.c) -o $@ $< $(LDLIBS)
#
# Typical archiver (library) command
# Library targets should be built as follows:
#  $(ARPREF)$(TARGET).$(AREXT)
#
AR=/usr/bin/ar
RANLIB=ranlib
ARFLAGS=r
ARPREF=lib
AREXT=a
.c.a:
	@$(COMPILE.c) -o `echo $< | sed -e 's@\.c@.o@'` $<
	@$(AR) $(ARFLAGS) $@ `echo $< | sed -e 's@\.c@.o@'`
	@$(RM) `echo $< | sed -e 's@\.c@.o@'`
	@$(RANLIB) $@


# misc file ops commands
RM=/bin/rm
MV=/bin/mv


# UIL support
UIL=uil
COMPILE.uil = \
	$(UIL) $(UILFLAGS)
.uil.uid:
	$(COMPILE.uil) -o $@ $<
	-@$(MV) $@ . >/dev/null 2>&1


############################################################
#                                                          #
# INDIVIDUAL PROGRAMER MODIFICATIONS HERE                  #
#                                                          #
# Note:  Source  and object files are lists of files       #
#        separated by spaces.  Use the backslash (\)  for  #
#        lists that span multiple lines.                   #
#                                                          #
############################################################

# Program to make (binary executable or library minus prefix & suffix)
TARGET  =  sdrtool

# Bindings used by one or more files in TARGET



# Header files for TARGET

INCLUDES.h = \
 ./sdr.h \
 ./sdr_.h \
 ./sdr_g.h \
 ./sdr_t.h \
 ./sdrtags.h \
 ./supported_tables.h

# Source files for TARGET

SOURCES.c = \
 ./SIGCHLD_handler.c \
 ./apply_abort_callback.c \
 ./create_callback.c \
 ./color_buttons.c \
 ./cursor_mgmt.c \
 ./destroy_main.c \
 ./docmd_callback.c \
 ./edit_file_callback.c \
 ./extract_from_window.c \
 ./fill_it_in.c \
 ./get_cpcname.c \
 ./get_current_record.c \
 ./get_discrep_rec.c \
 ./get_next_id.c \
 ./insert_discrep_rec.c \
 ./is_a_user.c \
 ./isvalidid.c \
 ./lockout_idfile.c \
 ./mail_me_one.c \
 ./printsdr.c \
 ./notify_user.c \
 ./abc_sdrtables.c \
 ./sdrtool_sdrtables.c \
 ./s_isdigit.c \
 ./sdrtool.c \
 ./set_cpc_option.c \
 ./sqlprintf.c \
 ./unlock_idfile.c \
 ./update_database.c \
 ./update_discrep_rec.c \
 ./value_changed_callback.c

SOURCES.uil = \
 ./sdr.uil \
 ./abc_sdrtables.uil \
 ./sdrtool_sdrtables.uil

SOURCES.o = \
	$(SOURCES.c:.c=.o)

OBJECTS = \
	$(SOURCES.o)


SOURCES.uid = \
	$(SOURCES.uil:.uil=.uid)

SOURCES.all = \
	./sdrtags.h \
	./sdrtags.uil \
	$(SOURCES.c) \
	$(SOURCES.uil)


#
# This is the default object to make (the first colon in the file)
#

$(TARGET): \
 $(INCLUDES.h) \
 $(OBJECTS) g$(TARGET)_include_keys.o $(SOURCES.uid) \
 $(SOURCES.all) g$(TARGET)_include_keys.c ./lib/libutilities.a
	$(LINK.c) -o $(TARGET) $(OBJECTS) g$(TARGET)_include_keys.o $(LDLIBS)

# Generate a list of functions called by sources in the list
calls:	$(SOURCES.c)
	-@$(RM) -f $(COMMONPATH)/calls/SDRTool.calls $(COMMONPATH)/calls/SDRTool.calls.c
	-@cat $(SOURCES.c) > $(COMMONPATH)/calls/SDRTool.calls.c
	@echo "Call Stack For SDRTool CPC" > $(COMMONPATH)/calls/SDRTool.calls
	@$(CALLS) -X -n -t -f main -c "cc  -E" $(CPPFLAGS) $(COMMONPATH)/calls/SDRTool.calls.c >> $(COMMONPATH)/calls/SDRTool.calls
	-@$(RM) -f $(COMMONPATH)/calls/SDRTool.calls.c
	@echo "Rebuilt callstack for SDRTool in $(COMMONPATH)/calls/SDRTool.calls"


# For CodeCenter to load the project
$(TARGET)_project:	$(INCLUDES.h) $(OBJECTS)
	#setopt program_name $(TARGET)
	#setopt load_flags $(CPPFLAGS) $(LDFLAGS)
	#setopt tab_stop 4
	#load $(CPPFLAGS) $(LDFLAGS) $(OBJECTS) $(LDLIBS)
	#link


# Log of what(1) marker lines for all include files used:
# The .c file is dependent upon all include files listed so that
# if one changes, the .c file is regenerated (& thus the .o)
g$(TARGET)_include_keys.c:  $(INCLUDES.h) $(SOURCES.uil)
	-@$(RM) -f g$(TARGET)_include_keys.*
	$(WHAT_HEADERS) -filename g$(TARGET)_include_keys.c \
		$(INCLUDES.h) $(SOURCES.uil) \
		>g$(TARGET)_include_keys.c

# Target to get it to just remake the uid files
uil:	$(SOURCES.uid)

sdr.uil:	./sdrtags.uil

# removes all object files, lintfiles and core if found
clean:
	-$(RM) -f $(OBJECTS) 
	-$(RM) -f g*_include_keys.* core a.out

# does clean above PLUS removes the target (executable or library)
clobber:	clean
	-$(RM) -f $(SOURCES.uid)
	-$(RM) -f $(TARGET)


# Provides make format list of sources and include file dependencies by
# examining includes & sources provided for includes using double quotes.
# Use list_includes for direct includes with double quotes
# Use list_all_includes for direct includes with double quotes AND <> brackets
# Use find_includes for direct AND indirect includes with double quotes
list_includes:
	$(LIST_INCLUDES) $(SOURCES.c) | sed -e 's@^\.@$.@' \
		>$(TARGET).includes


# Install target to $(COMMONPATH)/bin
install: $(TARGET)
	@echo "Install $(TARGET) in $(COMMONPATH)/bin"
	@install -f $(COMMONPATH)/bin $(TARGET)
	@install -f $(COMMONPATH)/bin sdr.uid

./sdrtags.h:	./sdrtags.def
	-@/bin/rm -f ./sdrtags.h >/dev/null 2>&1
	-mktags -c ./sdrtags.def ./sdrtags.h

./sdrtags.uil:	./sdrtags.def
	-@/bin/rm -f ./sdrtags.uil >/dev/null 2>&1
	-mktags -u ./sdrtags.def ./sdrtags.uil

./sdr.uil:	./sdrtags.h ./date_popup.uil

./abc_sdrtables.c:	./mkchoices.abc
	-@./mkchoices.abc sdrtables.uil sdrtables.c

./abc_sdrtables.uil:	./mkchoices.abc
	-@./mkchoices.abc sdrtables.uil sdrtables.c

./sdrtool_sdrtables.c:	./mkchoices.sdrtool
	-@./mkchoices.sdrtool sdrtables.uil sdrtables.c

./sdrtool_sdrtables.uil:	./mkchoices.sdrtool
	-@./mkchoices.sdrtool sdrtables.uil sdrtables.c

./lib/libutilities.a: ./lib/Makefile
	( cd ./lib ; make )

./include/generi.h: ./lib/generi.h
	@if (test ! -h ./include) then ; \
		ln -s ./lib ./include ; \
	fi

./include/generi_.h: ./lib/generi_.h
	@if (test ! -h ./include) then ; \
		ln -s ./lib ./include ; \
	fi

./include/generi_t.h: ./lib/generi_t.h
	@if (test ! -h ./include) then ; \
		ln -s ./lib ./include ; \
	fi
	
# Echo list of all files in INCLUDES.h and SOURCES.all to screen
echofiles:
	@echo $(INCLUDES.h) $(SOURCES.all)


$(TARGET).depend: depend

$(TARGET).mk.depend: replace_depend

depend:
	-@/bin/rm -f $(TARGET).depend* $(TARGET).depend.tmp* >/dev/null 2>&1
	-@touch $(TARGET).depend.tmp >/dev/null 2>&1
	@makedepend -o.o -w50 -f$(TARGET).depend.tmp -s# SOURCE_DEPENDENCIES_HERE--v -- $(CFLAGS) -I/include $(CINCLUDES) -- $(SOURCES.c) >/dev/null 2>&1
	@mkmk_filter_depend $(TARGET).depend.tmp >$(TARGET).depend
	-@/bin/rm -f $(TARGET).depend.tmp* >/dev/null 2>&1
	@echo "depend: Complete - results in $(TARGET).depend"



replace_depend: $(TARGET).mk $(TARGET).depend
	-@/bin/rm -f $(TARGET).mk.depend* $(TARGET).mk.depend.tmp* >/dev/null 2>&1
	@mkmk_replace_depend $(TARGET).mk $(TARGET).depend > $(TARGET).mk.depend.tmp
	@mkmk_replace_includes $(TARGET).mk.depend.tmp > $(TARGET).mk.depend
	-@/bin/rm -f $(TARGET).mk.depend.tmp* >/dev/null 2>&1
	@echo "replace_depend: Complete - new makefile in $(TARGET).mk.depend"

#
# Place Source Dependencies Here - no longer provided by mkmk
# Use make -f sdrtool.mk list_includes
#  Then check the resulting $(TARGET).includes file before merging it
#  with this makefile as it makes certain assumptions that may not always
#  be correct (hey, mkmk can't read minds, just source).
# Use show_includes $(TARGET) command to see a unique list of .h files
#  included by all files in the makefile after running the above list_includes
#  option.  The list produced by show_includes should match the list in
#  the INCLUDES.h macro in this makefile BEFORE merging the $(TARGET).includes
#  list below.
#
# SOURCE_DEPENDENCIES_HERE--v

# SOURCE_DEPENDENCIES_HERE--^
#
# End of sdrtool Makefile
# end file : sdrtool.mk
