#ifndef	lint
static char rcsid[] = "$Id: value_changed_callback.c,v 1.7 1995/04/01 02:33:52 sydd Exp sydd $ SyddWare";
#endif
/*****************************************************************************
* Classification:    Unclassified
*
* Project:           SDRTOOL
*
* Module Name:       value_changed_callback.c
*
* Description:
*   
*
* Calling Sequence:
*   
*
*   Inputs:
*       None
*
*   Outputs:
*       None
*
*   Returns:
*       None
*
* Error Conditions and Actions:
*   N/A
*
* Side Effects:
*   N/A
*
* Limitations:
*   N/A
*
* Notes:
*   N/A
*
* Revision History
*   DATE    S/W ENGINEER     DESCRIPTION OF WORK
* --------  ---------------  ------------------------------------------------
*
******************************************************************************/
 
#include "sdr_.h"

#ifndef XmIsArrowButton
#	define XmIsArrowButton(_w) XtIsSubclass(_w, xmArrowButtonWidgetClass)
#endif /* XmIsArrowButton */

void
value_changed_callback(w, tag, call)
	Widget w;
	int *tag;
	XmAnyCallbackStruct *call;
{
	XmTextVerifyCallbackStruct		*textfield;
	XmToggleButtonCallbackStruct	*togglebutton;
	char							*current_value = (char *)0;
	struct	tm						*duedate = (struct tm *)0;
	char							*text;
	Widget							monthwidgee;
	XmString						origstring;
	SDR_T							sdr;
	int								keylen = 0, index, month;
	XmTextPosition					pos_of_dot;
	KeySym							keysym;
	XComposeStatus					status;
	XtPointer						idvalid, prefix;
	XmStringContext					context;
	XmStringCharSet					charset;
	XmStringDirection				direction;
	Boolean							separator;
	Boolean     					isset;
	time_t							timenow;
	char							assigned_to[ASSIGNED_SIZE +1];
	char							keypress[20], tempstring[20];
	unsigned char					arrowdirection;

	textfield = (XmTextVerifyCallbackStruct *) call;
	togglebutton = (XmToggleButtonCallbackStruct *) call;

	RESET_MESSAGE("");
	if (call && call->event && call->event->type == KeyPress)
	{
		keylen = XLookupString((XKeyEvent *)textfield->event,
			keypress,sizeof(keypress),&keysym, &status);
	}
	switch (*tag)
	{
		case k_janpushButton:
		case k_febpushButton:
		case k_marpushButton:
		case k_aprpushButton:
		case k_maypushButton:
		case k_junpushButton:
		case k_julpushButton:
		case k_augpushButton:
		case k_seppushButton:
		case k_octpushButton:
		case k_novpushButton:
		case k_decpushButton:
            XtVaGetValues ( w,
                XmNuserData, &month,
                NULL );
			current_value = XmTextFieldGetString( Widget_list[k_daytextField]);
			sscanf(current_value,"%d", &index);
			switch (month)
			{
				case 1:
				case 3:
				case 5:
				case 7:
				case 8:
				case 10:
				case 12:
					keylen = 31;
					break;

				case 2:
					keylen = 28;
					break;

				case 4:
				case 6:
				case 9:
				case 11:
					keylen = 30;
					break;
			}
			if (index > keylen)
			{
				index = keylen;
				sprintf(tempstring,"%d", keylen);
				XmTextFieldSetString(Widget_list[k_daytextField], tempstring);
			}
			break;

		case k_duedatedrawnButton:
			XtVaGetValues( Widget_list[k_idtextField],
				XmNuserData, &idvalid,
				NULL);
			/* pop up a window to allow ccb user to set due date */
			if (!strcmp(username,SdrTool.cmaccountname) && idvalid)
			{
            	time(&timenow);
				/* default it to a week by adding 60sec*60min*24hr*7days */
				timenow += (60*60*24*7);
            	duedate = localtime(&timenow);
            	switch (duedate->tm_mon)
            	{
                	case 0: /* jan */
                    	XtVaSetValues(Widget_list[k_monthoptionMenu],
                        	XmNmenuHistory, Widget_list[k_janpushButton],
                        	NULL);
                    	break;
                	case 1: /* feb */
                    	XtVaSetValues(Widget_list[k_monthoptionMenu],
                        	XmNmenuHistory, Widget_list[k_febpushButton],
                        	NULL);
                    	break;
                	case 2: /* mar */
                    	XtVaSetValues(Widget_list[k_monthoptionMenu],
                        	XmNmenuHistory, Widget_list[k_marpushButton],
                        	NULL);
                    	break;
                	case 3: /* apr */
                    	XtVaSetValues(Widget_list[k_monthoptionMenu],
                        	XmNmenuHistory, Widget_list[k_aprpushButton],
                        	NULL);
                    	break;
                	case 4: /* may */
                    	XtVaSetValues(Widget_list[k_monthoptionMenu],
                        	XmNmenuHistory, Widget_list[k_maypushButton],
                        	NULL);
                    	break;
                	case 5: /* jun */
                    	XtVaSetValues(Widget_list[k_monthoptionMenu],
                        	XmNmenuHistory, Widget_list[k_junpushButton],
                        	NULL);
                    	break;
                	case 6: /* jul */
                    	XtVaSetValues(Widget_list[k_monthoptionMenu],
                        	XmNmenuHistory, Widget_list[k_julpushButton],
                        	NULL);
                    	break;
                	case 7: /* aug */
                    	XtVaSetValues(Widget_list[k_monthoptionMenu],
                        	XmNmenuHistory, Widget_list[k_augpushButton],
                        	NULL);
                    	break;
                	case 8: /* sep */
                    	XtVaSetValues(Widget_list[k_monthoptionMenu],
                        	XmNmenuHistory, Widget_list[k_seppushButton],
                        	NULL);
                    	break;
                	case 9: /* oct */
                    	XtVaSetValues(Widget_list[k_monthoptionMenu],
                        	XmNmenuHistory, Widget_list[k_octpushButton],
                        	NULL);
                    	break;
                	case 10: /* nov */
                    	XtVaSetValues(Widget_list[k_monthoptionMenu],
                        	XmNmenuHistory, Widget_list[k_novpushButton],
                        	NULL);
                    	break;
                	case 11: /* dec */
                    	XtVaSetValues(Widget_list[k_monthoptionMenu],
                        	XmNmenuHistory, Widget_list[k_decpushButton],
                        	NULL);
                    	break;
            	}
            	sprintf(tempstring,"%d",duedate->tm_mday);
            	XmTextFieldSetString(
                	Widget_list[ k_daytextField ],
                	tempstring);
            	sprintf(tempstring,"%d",duedate->tm_year + 1900);
            	XmTextFieldSetString(
                	Widget_list[ k_yeartextField ],
                	tempstring);
            	sprintf(tempstring,"%d",duedate->tm_hour);
            	XmTextFieldSetString(
                	Widget_list[ k_hourtextField ],
                	tempstring);
            	sprintf(tempstring,"%d",duedate->tm_min);
            	XmTextFieldSetString(
                	Widget_list[ k_minutetextField ],
                	tempstring);
				if (!XtIsManaged(Widget_list[k_datepopup]))
				{
					XtManageChild(Widget_list[k_datepopup]) ;	
								/* popup the popup*/
				}
			}
			break;

		case k_assesstoggleButton:
			if (Current_status &&
				Current_status == Widget_list[*tag] &&
				togglebutton->set && togglebutton->event &&
				ButtonRelease == togglebutton->event->type)
				return;
			if (!Current_status)
				Current_status = Widget_list[k_newtoggleButton];
			/* only need to check if user presses button */
			if (togglebutton->set && togglebutton->event &&
				ButtonRelease == togglebutton->event->type &&
				w != Current_status)
			{
				XtVaGetValues( Widget_list[k_idtextField],
					XmNuserData, &idvalid,
					NULL);
				if (!idvalid || strcmp(username,SdrTool.cmaccountname))
				{
					BEEP_MESSAGE("ID is invalid or Invalid USER for this function");
					if (!Previous_status)
						Previous_status = Widget_list[k_newtoggleButton];
					Current_status = Previous_status;
					XmToggleButtonSetState( w,
						False, False );
					XmToggleButtonSetState( Previous_status,
						True, False );
					XFlush(XtDisplay(Previous_status));
				}
				else
					Current_status = w;
			}
			else
			{
				if (!togglebutton->set)
					Previous_status = w;
				else
					Current_status = w;
			}
			break;

		case k_assignedtoggleButton:
			if (Current_status &&
				Current_status == Widget_list[*tag] &&
				togglebutton->set && togglebutton->event &&
				ButtonRelease == togglebutton->event->type)
				return;
			if (!Current_status)
				Current_status = Widget_list[k_newtoggleButton];
			/* only need to check if user presses button */
			if (togglebutton->set && togglebutton->event &&
				ButtonRelease == togglebutton->event->type &&
				w != Current_status)
			{
				XtVaGetValues( Widget_list[k_idtextField],
					XmNuserData, &idvalid,
					NULL);
				if (!idvalid || strcmp(username,SdrTool.cmaccountname))
				{
					BEEP_MESSAGE("ID is invalid or Invalid USER for this function");
					if (!Previous_status)
						Previous_status = Widget_list[k_newtoggleButton];
					Current_status = Previous_status;
					XmToggleButtonSetState( w,
						False, False );
					XmToggleButtonSetState( Previous_status,
						True, False );
					XFlush(XtDisplay(Previous_status));
                }
                else
                    Current_status = w;
			}
			else
			{
				if (!togglebutton->set)
					Previous_status = w;
				else
					Current_status = w;
			}
			break;

		case k_ccb2toggleButton:
			/* only need to check if user presses button */
			if (Current_status &&
				Current_status == Widget_list[*tag] &&
				togglebutton->set && togglebutton->event &&
				ButtonRelease == togglebutton->event->type)
				return;
			if (togglebutton->set && togglebutton->event &&
				ButtonRelease == togglebutton->event->type &&
                w != Current_status)
			{
				XtVaGetValues( Widget_list[k_idtextField],
					XmNuserData, &idvalid,
					NULL);
				if (!idvalid || strcmp(username,SdrTool.cmaccountname))
				{
					current_value = XmTextFieldGetString(
                		Widget_list[ k_assignedtextField ]);
    				strncpy(assigned_to,current_value, sizeof(assigned_to)-1);
    				assigned_to[sizeof(assigned_to)-1] = '\0';
    				XtFree(current_value);
					if (Previous_status !=
							Widget_list[k_assignedtoggleButton] ||
						emptyline(assigned_to) ||
						strcmp(username,assigned_to))
					{
						BEEP_MESSAGE("ID is invalid or Invalid USER for this function");
						if (!Previous_status)
							Previous_status =
								Widget_list[k_newtoggleButton];
						Current_status = Previous_status;
						XmToggleButtonSetState( w,
							False, False );
						XmToggleButtonSetState( Previous_status,
							True, False );
						XFlush(XtDisplay(Previous_status));
                	}
                	else
                    	Current_status = w;
				}
                else
                   	Current_status = w;
			}
			else
			{
				if (!togglebutton->set)
					Previous_status = w;
				else
					Current_status = w;
			}
			break;

		case k_newtoggleButton:
			if (Current_status &&
				Current_status == Widget_list[*tag] &&
				togglebutton->set && togglebutton->event &&
				ButtonRelease == togglebutton->event->type)
				return;
			/* only need to check if user presses button */
			if (togglebutton->set && togglebutton->event &&
				ButtonRelease == togglebutton->event->type &&
				w != Current_status)
			{
				XtVaGetValues( Widget_list[k_idtextField],
					XmNuserData, &idvalid,
					NULL);
				if (!idvalid)
				{
					BEEP_MESSAGE("ID is not valid");
					if (!Previous_status)
						Previous_status = Widget_list[k_newtoggleButton];
					Current_status = Previous_status;
					XmToggleButtonSetState( w,
						False, False );
					XmToggleButtonSetState( Previous_status,
						True, False );
					XFlush(XtDisplay(Previous_status));
				}
				else if (strcmp(username,SdrTool.cmaccountname))
				{
					current_value = XmTextFieldGetString(
                		Widget_list[ k_assignedtextField ]);
    				strncpy(assigned_to,current_value, sizeof(assigned_to)-1);
    				assigned_to[sizeof(assigned_to)-1] = '\0';
    				XtFree(current_value);
					if (Previous_status !=
							Widget_list[k_assesstoggleButton] ||
						emptyline(assigned_to) ||
						strcmp(username,assigned_to))
					{
						BEEP_MESSAGE("SDR must be assigned to someone");
						if (!Previous_status)
							Previous_status =
								Widget_list[k_newtoggleButton];
						Current_status = Previous_status;
						XmToggleButtonSetState( w,
							False, False );
						XmToggleButtonSetState( Previous_status,
							True, False );
						XFlush(XtDisplay(Previous_status));
					}
					else
						Current_status = w;
				}
				else
					Current_status = w;
			}
			else
			{
				if (!togglebutton->set)
					Previous_status = w;
				else
					Current_status = w;
			}
			break;

		case k_cmevaltoggleButton:
		case k_promotetoggleButton:
		case k_resolvedtoggleButton:
		case k_rejectedtoggleButton:
			if (Current_status &&
				Current_status == Widget_list[*tag] &&
				togglebutton->set && togglebutton->event &&
				ButtonRelease == togglebutton->event->type)
				return;
			/* only need to check if user presses button */
			if (togglebutton->set && togglebutton->event &&
				ButtonRelease == togglebutton->event->type &&
				w != Current_status)
			{
				XtVaGetValues( Widget_list[k_idtextField],
					XmNuserData, &idvalid,
					NULL);
				if (!idvalid || strcmp(username,SdrTool.cmaccountname))
				{
					BEEP_MESSAGE("Invalid USER for this function");
					if (!Previous_status)
						Previous_status = Widget_list[k_newtoggleButton];
					Current_status = Previous_status;
					XmToggleButtonSetState( w,
						False, False );
					XmToggleButtonSetState( Previous_status,
						True, False );
					XFlush(XtDisplay(Previous_status));
				}
				else
					Current_status = w;
			}
			else
			{
				if (!togglebutton->set)
					Previous_status = w;
				else if (togglebutton->event &&
					ButtonRelease == togglebutton->event->type)
					Current_status = w;
			}
			break;

		case k_hourstextField:
			/*
			**	Note: in most cases, textfield->text->ptr will contain the
			**	text.  However, this is null when unprintables are struck
			**	such as backspace which we may want.  You COULD use the
			**	startPos, endPos etc. values to figure out what just happened,
			**	or simply use the value obtained from the event struct
			**	which can be directly interrogated.
			*/
			if (call->event && call->event->type == KeyPress && keylen &&
				textfield->reason == XmCR_MODIFYING_TEXT_VALUE)
			{
				XtVaGetValues(w,XmNuserData, &pos_of_dot, NULL);
				switch (keypress[0])
				{
					case '0':
					case '1':
					case '2':
					case '3':
					case '4':
					case '5':
					case '6':
					case '7':
					case '8':
					case '9':
						if (pos_of_dot != -1 &&
							textfield->startPos >= pos_of_dot + 3)
						{	/* only 2 decimal places allowed */
							textfield->doit = False;
						}
						break;

					case '.':
						if (pos_of_dot != -1)
							textfield->doit = False;
						else
						{
							pos_of_dot = textfield->currInsert;
							XtVaSetValues(w, XmNuserData, pos_of_dot,NULL);
						}
						break;

#ifndef	ASCII_BS
#	define	ASCII_BS	0x08
#endif	/* ASCII_BS */
					case ASCII_BS:
						if (textfield->startPos == pos_of_dot)
						{
							pos_of_dot = -1;
							XtVaSetValues(w,XmNuserData, pos_of_dot,NULL);
						}
						break;

					default:
						textfield->doit = False;
						break;
				}
			}
			break;

		case k_idtextField:
			/* simple non-keypress focus change should do nothing */
			if (textfield->event && textfield->event->type == KeyPress)
			{
            	/* KeyPresses: don't let em change it if any files are open */
            	textfield->doit = True;
            	for (index=0;Process_table[index].extension;++index)
            		if (Process_table[index].pid != -1 &&
                    	strcmp(Process_table[index].extension,HELP_FILE_EXT))
                	{
                    	BEEP_MESSAGE(
							"Please finish editing files & exit editors");
                    	textfield->doit = False;
                    	break;
                	}
            	if (!textfield->doit)
                	break;
			}

            if (call->event && call->event->type == KeyPress && keylen &&
                textfield->reason == XmCR_MODIFYING_TEXT_VALUE)
			{
				/* indicate that field is changing */
				XtVaSetValues( w, XmNuserData, False, NULL);
				switch (textfield->startPos)
				{
					case 0:
						if (textfield->text && textfield->text->ptr)
						{
							s_toupper(textfield->text->ptr);
							switch (textfield->text->ptr[0])
							{
								case DOCUMENTATION_PREFIX:
								case HARDWARE_PREFIX:
								case ORIGINAL_PREFIX:	/* also used for NEW */
								case SOFTWARE_PREFIX:
								case TOOL_PREFIX:
								case VENDOR_PREFIX:
									break;
								default:
									textfield->doit = False;
									break;
							}
						}
						break;

					case 1:
						current_value = XmTextFieldGetString( w );
						if (current_value)
						{
							if (current_value[0] == ORIGINAL_PREFIX)
							{
								if (keypress[0] != 'e' && keypress[0] != 'E' &&
									ASCII_BS != keypress[0] &&
									!isdigit(keypress[0]))
									textfield->doit = False;
								else if (textfield->text &&
									textfield->text->ptr)
									s_toupper(textfield->text->ptr);
							}
							else if (!isdigit(keypress[0]) &&
									ASCII_BS != keypress[0])
								textfield->doit = False;
						}
						break;

					case 2:
						current_value = XmTextFieldGetString( w );
						if (current_value)
						{
							if (current_value[0] == ORIGINAL_PREFIX)
							{
								if (current_value[1] == 'E' &&
								    (keypress[0] == 'w' ||
									 keypress[0] == 'W') &&
									textfield->text &&
                                    textfield->text->ptr)
                                    s_toupper(textfield->text->ptr);
								else if ((isdigit(current_value[1]) &&
									ASCII_BS != keypress[0] &&
									!isdigit(keypress[0])) ||
									(current_value[1] == 'E' &&
									 !(keypress[0] == 'w' ||
                                       keypress[0] == 'W' ||
									   ASCII_BS == keypress[0])))
									textfield->doit = False;
								else if (textfield->text &&
									textfield->text->ptr)
									s_toupper(textfield->text->ptr);
							}
							else if (!isdigit(keypress[0]) &&
								ASCII_BS != keypress[0])
								textfield->doit = False;
						}
						break;

					case 3:
					case 4:
					case 5:
						current_value = XmTextFieldGetString( w );
						if (!strcmp(current_value,"NEW") ||
							(!isdigit(keypress[0]) &&
							 ASCII_BS != keypress[0]))
							textfield->doit = False;
						break;

					default:
						textfield->doit = False;
						break;
				}
			}
			else if (textfield->reason == XmCR_LOSING_FOCUS &&
				textfield->event && textfield->event->type == KeyPress)
			{
				current_value = XmTextFieldGetString( w );
				if (!emptyline(current_value) &&
					strcmp(current_value,"NEW") &&
					strlen(current_value) == ID_CODE_SIZE)
				{
					cursor_mgmt(XtParent(w), TRUE);
					strcpy(sdr.id[0],current_value);
					if (get_current_record(&sdr) ||
						emptyline(sdr.id[0]))	/* not found */
					{
						textfield->doit = False;
						BEEP_MESSAGE("SDR not found");
					}
					else
					{
						/* indicate that field has been gotten */
						XtVaSetValues( w, XmNuserData, True, NULL);
						FILL_IT_IN(sdr);

						origstring = XmStringCreateLtoR(
							XmTextFieldGetString(Widget_list[k_idtextField]),
							XmFONTLIST_DEFAULT_TAG);
						XtVaSetValues(Widget_list[k_whichsdrlabel],
							XmNlabelString, origstring,
							NULL);
						XmStringFree(origstring);

						if (!strcmp(username,SdrTool.cmaccountname))
						{
							if (!XtIsSensitive(Widget_list[k_priorityscale]))
								XtSetSensitive(Widget_list[k_priorityscale],
									True);
						}
						else if (XtIsSensitive(Widget_list[k_priorityscale]))
							XtSetSensitive(Widget_list[k_priorityscale],
								False);
					}
					cursor_mgmt(XtParent(w), FALSE);
				}
				else if (!XtIsSensitive(Widget_list[k_priorityscale]))
					XtSetSensitive(Widget_list[k_priorityscale], True);
			}
			break;

		case k_catiddrawnButton:
			XtVaGetValues( Widget_list[k_idtextField],
				XmNuserData, &idvalid,
				NULL);
			/* pop up a window to allow ccb user to assign N class to other */
			if (!strcmp(username,SdrTool.cmaccountname) && idvalid)
			{
                XtVaGetValues(Widget_list[k_catiddrawnButton],
                    XmNlabelString, &origstring, NULL);
                XmStringInitContext(&context,origstring);
                XmStringGetNextSegment(context,
                    &text, &charset, &direction, &separator);
                XmStringFreeContext(context);
                XmStringFree(origstring);
                /* Expected text: "Perm #: N#####" */
				if (text[8] == ORIGINAL_PREFIX ||
                    text[8] == tolower(ORIGINAL_PREFIX) ||
					!strcmp(&text[9],"#####"))
				{
					XtManageChild(Widget_list[k_sdrtypepopup]) ;	
								/* popup the popup*/
				}
				XmStringFree(text);
			}
			break;

		case k_masteriddrawnButton:
			XtVaGetValues( Widget_list[k_idtextField],
				XmNuserData, &idvalid,
				NULL);
			/* pop up a window to allow user to see/do validate/perform */
			if (idvalid)
			{
				/* only desensitize Do perform button for all but CM */
				if (strcmp(username,SdrTool.cmaccountname) &&
					XtIsSensitive(Widget_list[k_doperformpushButton]))
					XtSetSensitive(Widget_list[k_doperformpushButton],
						False);
				else if (!strcmp(username,SdrTool.cmaccountname) &&
					!XtIsSensitive(Widget_list[k_doperformpushButton]))
					XtSetSensitive(Widget_list[k_doperformpushButton],
						True);

				origstring = XmStringCreateLtoR(
					XmTextFieldGetString(Widget_list[k_idtextField]),
					XmFONTLIST_DEFAULT_TAG);
				XtVaSetValues(Widget_list[k_whichsdrlabel],
					XmNlabelString, origstring,
					NULL);
				XmStringFree(origstring);

				if (!XtIsManaged(Widget_list[k_cmpopup]))
				{
					XtManageChild(Widget_list[k_cmpopup]) ;	
								/* popup the popup*/
				}
			}
			break;

		case k_softwareButton:
		case k_hardwareButton:
		case k_documentButton:
		case k_toolButton:
		case k_vendorButton:
		case k_unselectedButton:
			if (togglebutton && togglebutton-> set)
			{
				XtUnmanageChild(Widget_list[k_sdrtypepopup]) ;	
								/* close the popup*/
				XtVaGetValues( Widget_list[*tag],
					XmNuserData, &prefix,
					NULL);
				sprintf(tempstring,"Perm #: %s#####", prefix);
				origstring = XmStringCreateLtoR(tempstring,
					XmFONTLIST_DEFAULT_TAG);
				XtVaSetValues(Widget_list[k_catiddrawnButton],
					XmNlabelString, origstring,
					NULL);
				XmStringFree(origstring);
			}
			break;

		case k_softtoggleButton:
			XtVaGetValues(Widget_list[k_softtoggleButton], XmNset, &isset, 
						NULL) ;	
			XtVaGetValues( Widget_list[*tag], XmNuserData, &index, NULL);

			if (index)
				XtVaSetValues(Widget_list[k_softtoggleButton], XmNuserData,
						0, NULL) ;				
			else if (!XtIsManaged(Widget_list[k_stypepopup]) && isset)
					XtManageChild(Widget_list[k_stypepopup]) ;	
								/* close the popup*/
			break;

		case k_hardtoggleButton:
			XtVaGetValues(Widget_list[k_hardtoggleButton], XmNset, &isset, 
						NULL) ;	
			XtVaGetValues( Widget_list[*tag], XmNuserData, &index, NULL);

			if (index)
				XtVaSetValues(Widget_list[k_hardtoggleButton], XmNuserData,
						0, NULL) ;				
			else if (!XtIsManaged(Widget_list[k_htypepopup]) && isset)
				XtManageChild(Widget_list[k_htypepopup]) ;	
								/* close the popup*/
			break;

		case k_documenttoggleButton:
			XtVaGetValues(Widget_list[k_documenttoggleButton], XmNset, &isset, 
						NULL) ;	
			XtVaGetValues( Widget_list[*tag], XmNuserData, &index, NULL);

			if (index)
				XtVaSetValues(Widget_list[k_documenttoggleButton], XmNuserData,
						0, NULL) ;				
			else if (!XtIsManaged(Widget_list[k_dtypepopup]) && isset)
				XtManageChild(Widget_list[k_dtypepopup]) ;	
								/* close the popup*/
			break;

		case k_tooltoggleButton:
			XtVaGetValues(Widget_list[k_tooltoggleButton], XmNset, &isset, 
						NULL) ;	
			XtVaGetValues( Widget_list[*tag], XmNuserData, &index, NULL);

			if (index)
				XtVaSetValues(Widget_list[k_tooltoggleButton], XmNuserData,
						0, NULL) ;				
			else if (!XtIsManaged(Widget_list[k_ttypepopup]) && isset)
				XtManageChild(Widget_list[k_ttypepopup]) ;	
								/* close the popup*/
			break;

		case k_vendortoggleButton:
			XtVaGetValues(Widget_list[k_vendortoggleButton], XmNset, &isset, 
						NULL) ;	
			XtVaGetValues( Widget_list[*tag], XmNuserData, &index, NULL);

			if (index)
				XtVaSetValues(Widget_list[k_vendortoggleButton], XmNuserData,
						0, NULL) ;				
			else if (!XtIsManaged(Widget_list[k_vtypepopup]) && isset)
				XtManageChild(Widget_list[k_vtypepopup]) ;	
								/* close the popup*/
			break;

		case k_maildrawnButton:
			if (!XtIsManaged(Widget_list[k_mailerpopup]))
			{
				XtVaGetValues( Widget_list[k_idtextField],
					XmNuserData, &idvalid,
					NULL);
				/* pop up a window to allow user to see/do validate/perform */
				if (idvalid)
				{
					if (emptyline(XmTextFieldGetString(
						Widget_list[ k_totextField ])))
						XmTextFieldSetString(Widget_list[ k_totextField ],
							username);

					if (emptyline(XmTextFieldGetString(
						Widget_list[ k_subjecttextField ])))
						XmTextFieldSetString(Widget_list[ k_subjecttextField ],
							"SdrTool: You wanted a copy of this one?");

 					XtManageChild(Widget_list[k_mailerpopup]) ;	
								/* open the popup*/
				}
				else
				{
					BEEP_MESSAGE("Choose an SDR first");
				}
			}
			break;

		case k_senditpushButton:
		case k_nevermindpushButton:
			if (XtIsManaged(Widget_list[k_mailerpopup]))
 				XtUnmanageChild(Widget_list[k_mailerpopup]) ;	
								/* close the popup*/
			break;

		case k_softwareunknownButton:
		case k_sunknownpushButton:
			XtVaGetValues(w, XmNuserData, &index, NULL) ;	
			XtVaSetValues(Widget_list[k_styperadioBox], XmNuserData,
					 index, NULL) ;	
			if (XtIsManaged(Widget_list[k_stypepopup]))
 				XtUnmanageChild(Widget_list[k_stypepopup]) ;	
								/* close the popup*/
			break;

		case k_hardwareunknownButton:
		case k_hunknownpushButton:
			XtVaGetValues(w, XmNuserData, &index, NULL) ;	
			XtVaSetValues(Widget_list[k_htyperadioBox], XmNuserData,
					 index, NULL) ;	
			if (XtIsManaged(Widget_list[k_htypepopup]))
				XtUnmanageChild(Widget_list[k_htypepopup]) ;	
								/* close the popup*/
			break;

		case k_documentunknownButton:
		case k_dunknownpushButton:
			XtVaGetValues(w, XmNuserData, &index, NULL) ;	
			XtVaSetValues(Widget_list[k_dtyperadioBox], XmNuserData,
					 index, NULL) ;	
			if (XtIsManaged(Widget_list[k_dtypepopup]))
					XtUnmanageChild(Widget_list[k_dtypepopup]) ;	
								/* close the popup*/
			break;

		case k_tooltextField:
			if (textfield &&
				textfield->event && textfield->event->type == KeyPress &&
				(keylen = XLookupString((XKeyEvent *)textfield->event,
					keypress,sizeof(keypress),&keysym, &status)) > 0 &&
					!(keypress[(keylen >= sizeof(keypress)) ?
						sizeof(keypress)-1 : keylen] = '\0') &&
					strchr(keypress,'\t') &&
					XtIsManaged(Widget_list[k_ttypepopup]))
			{
				/*
				** close the popup when they press TAB which gets here as
				** a losing focus event with a KeyPress event
				*/
				XtUnmanageChild(Widget_list[k_ttypepopup]) ;	
								/* close the popup*/
			}
			break;

		case k_vendorunknownButton:
		case k_vunknownpushButton:
			XtVaGetValues(w, XmNuserData, &index, NULL) ;	
			XtVaSetValues(Widget_list[k_vtyperadioBox], XmNuserData,
					 index, NULL) ;	
			if (XtIsManaged(Widget_list[k_vtypepopup]))
				XtUnmanageChild(Widget_list[k_vtypepopup]) ;	
								/* close the popup*/
			break;

		case k_daytextField:
		case k_yeartextField:
		case k_hourtextField:
		case k_minutetextField:
			if (XmIsArrowButton(w))
			{
				current_value = XmTextFieldGetString( Widget_list[*tag] );
				XtVaGetValues(w, XmNarrowDirection, &arrowdirection, NULL) ;	
				sscanf(current_value,"%d",&index);
				if (arrowdirection == XmARROW_UP)
					++index;
				else
					--index;
				switch (*tag)
				{
					case k_minutetextField:
						if (index < 0)
							index = 59;
						else if (index > 59)
							index = 0;
						break;

					case k_hourtextField:
						if (index < 0)
							index = 23;
						else if (index > 23)
							index = 0;
						break;

					case k_yeartextField:
						if (!index)
							--index;
						break;

					case k_daytextField:
						XtVaGetValues( Widget_list[ k_monthoptionMenu ],
							XmNmenuHistory, &monthwidgee,
							NULL);
						XtVaGetValues( monthwidgee,
							XmNuserData, (XtPointer)&month,
							NULL);
						switch (month)
						{
							case 1:
							case 3:
							case 5:
							case 7:
							case 8:
							case 10:
							case 12:
								keylen = 31;
								break;

							case 2:
								keylen = 28;
								break;

							case 4:
							case 6:
							case 9:
							case 11:
								keylen = 30;
								break;
						}
						if (index < 1)
							index = keylen;
						else if (index > keylen)
							index = 1;
						break;
				}
						
				sprintf(tempstring,"%d",index);
				XmTextFieldSetString( Widget_list[*tag],
					tempstring);
			}
			break;

		default:
			break;
	}
	return;
}
