#ifndef	lint
static char sccsid[] = "$Id: unlock_idfile.c,v 1.1 1995/01/24 05:16:42 sydd Exp $ SyddWare";
#endif
/*****************************************************************************
* Classification:    Unclassified
*
* Project:           SDRTOOL
*
* Module Name:       unlock_idfile.c
*
* Description:
*   
*
* Calling Sequence:
*   
*
*   Inputs:
*       None
*
*   Outputs:
*       None
*
*   Returns:
*       None
*
* Error Conditions and Actions:
*   N/A
*
* Side Effects:
*   N/A
*
* Limitations:
*   N/A
*
* Notes:
*   N/A
*
* Revision History
*   DATE    S/W ENGINEER     DESCRIPTION OF WORK
* --------  ---------------  ------------------------------------------------
*
******************************************************************************/
#include <Xm/Xm.h>
#include "sdr_.h"
#include "sdrtags.h"

#ifdef	COMMENT_OUT
int	gethostname
	PROTO((	char *hostname,
			int	namesize ));
#endif	/* COMMENT_OUT */

BOOLEAN	unlock_idfile(idfilename)
	char *idfilename;
{
/*
**	returns FALSE lock disengaged,
**	TRUE with errno set otherwise
*/
	FILE	*lockf = (FILE *)0;
	pid_t	matchpid = -1;
	int		save_errno;
	char	buffer[256];	/* for line reads from file */
	char	newbuffer[256];	/* for line reads from file */

	if (!idfilename)
	{
		errno = EINVAL;
		return TRUE;
	}
	else if (access(idfilename,NOTEXIST))
	{
		sprintf( buffer, "Lockfile [%s] nonexistent - Ouch something's wrong",
			idfilename);
		BEEP_MESSAGE(buffer);
		errno = ENOENT;
		return TRUE;
	}

	if (!(lockf = fopen(idfilename,"r")))	/* never got it */
	{
		save_errno = errno;
		sprintf( buffer,
		"Cannot open for read access Lockfile [%s] - Ouch something's wrong",
			idfilename);
		BEEP_MESSAGE(buffer);
		errno = save_errno;
		return TRUE;
	}

	gethostname(buffer,sizeof(buffer));	/* NOBODY has an 80 char hostname! */
	fscanf(lockf,"Process %d on %s has the lock", (int *)&matchpid, newbuffer);
	fclose(lockf);

	if (getpid() != matchpid ||
		strcmp(newbuffer,buffer))
	{
		sprintf( buffer, "Error - Lockfile [%s] is %s:Pid(%d)'s",
			idfilename, newbuffer, matchpid);
		BEEP_MESSAGE(buffer);
		errno = EACCES;
		return TRUE;
	}
	remove(idfilename);
	return FALSE;
}
